/* Copyright (c) 2009, Roi M. (foxtab@gmail.com)
 * All rights reserved.
 * See License.txt for further details.
 */

var foxTab = {

	WINDOW_CHROME_URL	   : "chrome://foxtab/content/window.xul",
	BIG_THUMBNAIL_SCALE		: 0.5,
	CACHED_SITE_DIR		   : "",
	FOXTAB_DIR			   : "",
	FOXTAB_DIR_NAME        : "foxtab",
	CACHE_SITE_DIR_NAME    : "thumbs",
	TIME_CACHE_DELTA	   : 2000,

	isWindowOpen		   : false,
	isFlashOpen			   : false,

	foxTabWindow		   : null, 

	workAroundHeightDelta  : 0,		
	isFirstSizeCalculation : true,
	biggestWindowWidth	   : 0,
	biggestWindowHeight    : 0,
	windowBoxObject        : {},

	loadOnFirefoxStart     : true,
	interval			   : null,
	canvas				   : null,
	gBrowser			   : null,
	container		       : null,
    pref				   : {},

    windowId			   : 0,

	url_list		       : null,
	url_allow_list		   : null,
	url_to_file_name	   : null,
	fileNameCounter 	   : 0,
	quickLaunchKey         : 9,
	staticLaunchKey        : 9,
	isFlashPlayerInstalled : true,
	disableTabSelected     : false,
	disableRecentlyUsedPush : false, 
	mode				   : 4,

	win                    : window,
	tabsList               : null, 
	OS                     : "",
	isFoxTabEnabled		   : true, 
	VERSION                : "1.2",
	FOXTAB_GUID            : "{ef4e370e-d9f0-4e00-b93e-a4f274cfdd5a}",
	WINDOWS				   : "winnt",
	LINUX				   : "linux",
	MAC					   : "darwin",
	firefoxVer             : null,

	CANVAS_INNER           : "canvasInner",
	CANVAS_FLOAT           : "canvasFloat",
	CANVAS_WIN             : "canvasWin",
	canvasType             : "canvasFloat",
 
	LAUNCH_MODE_INTERACTIVE: "interactive",	
	LAUNCH_MODE_QUICK      : "quick",	
	launchMode             : "quick",

	ENABLE_MEM_HANDLING    : true, 
	MEM_CLEAR_TIME         : 20 * 1000, 
	MEM_WRITE_TIME         : 8 * 1000,

	init : function() {
		var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var e = wm.getEnumerator(null);
		var bwr = e.getNext();

		if (bwr.foxTabGlobal==null) bwr.foxTabGlobal = {}
		if (bwr.foxTabGlobal.windowId==null)		  bwr.foxTabGlobal.windowId = 0
		if (bwr.foxTabGlobal.mostRecentlyUsedList==null) bwr.foxTabGlobal.mostRecentlyUsedList = new Array();

		bwr.foxTabGlobal.windowId++

		while (e.hasMoreElements()) {
			var w = e.getNext();
			if (w.foxTabGlobal==null) w.foxTabGlobal = {}
			w.foxTabGlobal.windowId       = bwr.foxTabGlobal.windowId
			w.foxTabGlobal.mostRecentlyUsedList = bwr.foxTabGlobal.mostRecentlyUsedList
		}

		foxTab.windowId				= bwr.foxTabGlobal.windowId
		foxTab.mostRecentlyUsedList  = bwr.foxTabGlobal.mostRecentlyUsedList		

		foxTab.url_list		    = new Array();
		foxTab.url_allow_list   = new Array();
		foxTab.url_to_file_name = new Array();

		// Operating system detection
		var cacheInTempdir;
		try{
			// Returns "WINNT" on Windows Vista, XP, 2000, and NT systems;  
			// "Linux" on GNU/Linux; and "Darwin" on Mac OS X.  
			var osString = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;  
			switch (osString.toLowerCase()) {
					case foxTab.WINDOWS:
						foxTab.OS = foxTab.WINDOWS  // Windows Vista, XP, 2000, and NT systems;  
						cacheInTempdir = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getBoolPref("foxTab.system.windows.cacheInTempdir");
						break;
					case foxTab.LINUX:
						foxTab.OS = foxTab.LINUX  // GNU/Linux
						cacheInTempdir = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getBoolPref("foxTab.system.linux.cacheInTempdir");
						break;
					case foxTab.MAC:
						foxTab.OS = foxTab.MAC 	// MAC OSX/Darwin
						cacheInTempdir = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getBoolPref("foxTab.system.osx.cacheInTempdir");
						break;
					default : foxTab.OS = foxTab.WINDOWS
							  cacheInTempdir = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getBoolPref("foxTab.system.windows.cacheInTempdir");
			}
		}catch(e){
		    foxTab.OS = foxTab.WINDOWS
			cacheInTempdir = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getBoolPref("foxTab.system.windows.cacheInTempdir");
		} 
		
		var appDir = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
		appDir.append(foxTab.FOXTAB_DIR_NAME); 
		cacheDir = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get(cacheInTempdir ? "TmpD" : "ProfD" ,Components.interfaces.nsIFile);
		cacheDir.append(foxTab.FOXTAB_DIR_NAME); 	 
		cacheDir.append(foxTab.CACHE_SITE_DIR_NAME); 
		foxTab.cacheDir = cacheDir;

		switch (foxTab.OS) {
			case foxTab.WINDOWS:
				foxTab.FOXTAB_DIR = appDir.path+"\\";
				foxTab.CACHED_SITE_DIR = cacheDir.path+"\\";
				break;
			case foxTab.LINUX:			
			case foxTab.MAC:
				foxTab.FOXTAB_DIR = appDir.path+"/";
				foxTab.CACHED_SITE_DIR = cacheDir.path+"/";
				break;
		}

		// Run once
		if (bwr.foxTabGlobal.foxTabDirectoryCreated==null) { // first browser window session
			/***************************************************************************************/
			// Flash truested file
			switch (foxTab.OS) {
					case foxTab.WINDOWS:
						var fl = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("AppData", Components.interfaces.nsIFile);
						var fp = fl.path + "\\Macromedia\\Flash Player\\#Security\\FlashPlayerTrust\\foxTabTrusted.txt"
					break;
					case foxTab.LINUX:
						var fl = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("Home", Components.interfaces.nsIFile);
						var fp =  fl.path + "/.macromedia/Flash_Player/#Security/FlashPlayerTrust/foxTabTrusted.txt"
					break;
					case foxTab.MAC:
						var fl=Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ULibDir", Components.interfaces.nsIFile);
						var fp = fl.path + "/Preferences/Macromedia/Flash Player/#Security/FlashPlayerTrust/foxTabTrusted.txt"
					break;
			}
			// save a text file to allow the flash to read local images files
			foxTab.saveTextFile(fp, foxTab.WINDOW_CHROME_URL)

		    try {
				if( !appDir.exists() || !appDir.isDirectory() ) {   // if it doesn't exist, create
				   appDir.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
				}		  
			} catch (e) {}	

		    try {
				if( !cacheDir.exists() || !cacheDir.isDirectory() ) {   // if it doesn't exist, create
				   cacheDir.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
				} else {
				   // removes the last session thumbnails
				   cacheDir.remove(true);
				   cacheDir.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
				}			  
			} catch (e) {}

			/***************************************************************************************/
			bwr.foxTabGlobal.foxTabDirectoryCreated = true;
		}
		
		var e = wm.getEnumerator(null);
		while (e.hasMoreElements()) {
			var w = e.getNext();
			if (w.foxTabGlobal==null) w.foxTabGlobal = {}
			w.foxTabGlobal.foxTabDirectoryCreated       = bwr.foxTabGlobal.foxTabDirectoryCreated
		}

		window.addEventListener("resize" , foxTab.onResize, false);

		window.addEventListener("keyup"  , foxTab.onKeyUp, false);
		window.addEventListener("keydown", foxTab.onKeyDown, false);

		window.addEventListener("unload" , foxTab.onUnLoad, false);
		window.addEventListener("load"   , foxTab.onLoad, false);
		window.addEventListener("flashblockCheckLoad", foxTab.flashBlockEvent, true, true)
	
		var uninstallObserver = {
		  observe: function(subject,topic,data){
			  if ((topic == "em-action-requested") && (data == "item-uninstalled")) {
				  var updateItem = subject.QueryInterface(Components.interfaces.nsIUpdateItem);
				  if (updateItem.id==foxTab.FOXTAB_GUID) {
					foxTab.gBrowser.selectedTab = gBrowser.addTab("http://www.foxtab.com/" + foxTab.VERSION + "/uninstall/");
					observerService.removeObserver(uninstallObserver,"em-action-requested");
				  }
			  }

		  }
		};

		var observerService =
		  Components.classes["@mozilla.org/observer-service;1"]
			.getService(Components.interfaces.nsIObserverService);
		observerService.addObserver(uninstallObserver,"em-action-requested",false);
		
	},
	
	mouseGestures : {

		init : function() {

			this.MOUSE_GESTURE_MIDDLE_DOUBLE_CLICK = true;
			this.MOUSE_GESTURE_LEFT_MIDDLE_PRESSED = foxTab.pref.gestureLeftMiddle;		  // interactive - mouse left and middle buttons pressed
			this.MOUSE_GESTURE_LEFT_RIGHT_PRESSED  = foxTab.pref.gestureLeftRight;		  // interactive - mouse left and right buttons pressed
			this.MOUSE_GESTURE_RIGHT_WHEEL		   = foxTab.pref.gestureRightClickScroll; // quick - right button + mouse wheel
			this.MOUSE_GESTURE_CTRL_WHEEL		   = foxTab.pref.gestureCtrlScroll;		  // quick - ctrl key pressed + mouse wheel

			this.isOpenByGesture = false;
			this.isGestureQuickMode = false;

			this.mouseButtonDown = -1;

			if ((this.MOUSE_GESTURE_LEFT_RIGHT_PRESSED) || (this.MOUSE_GESTURE_LEFT_MIDDLE_PRESSED) || (this.MOUSE_GESTURE_RIGHT_WHEEL)) {
				if (this.listenerInitialized==null) {
					window.addEventListener("mousedown", this.onMouseDown, false);
					window.addEventListener("mouseup", this.onMouseUp, false);
					window.addEventListener("click", this.onMouseClick, false);
					this.listenerInitialized = true;
				}
				if ((foxTab.OS==foxTab.MAC) || (foxTab.OS==foxTab.LINUX)) {
					if ((this.MOUSE_GESTURE_LEFT_RIGHT_PRESSED) || (this.MOUSE_GESTURE_RIGHT_WHEEL)) {
						window.addEventListener("contextmenu", this.onLinuxMacContextMenu, true, true);
						this.onLinuxMacContextRegister = true;
					} else {
						if (this.onLinuxMacContextRegister) {
							window.removeEventListener("contextmenu", this.onLinuxMacContextMenu, true, true);
							this.onLinuxMacContextRegister = false
						}
					}
				}
			} else {
				if (this.listenerInitialized!=null) {
					window.removeEventListener("mousedown", this.onMouseDown, false);
					window.removeEventListener("mouseup", this.onMouseUp, false);
					window.removeEventListener("click", this.onMouseClick, false);
					if ((foxTab.OS==foxTab.MAC) || (foxTab.OS==foxTab.LINUX)) {
						if (this.onLinuxMacContextRegister) {
							window.removeEventListener("contextmenu", this.onLinuxMacContextMenu, true, true);
							this.onLinuxMacContextRegister = false
						}
					}
					this.listenerInitialized = null;
				}
			}

			if ((this.MOUSE_GESTURE_RIGHT_WHEEL) || (this.MOUSE_GESTURE_CTRL_WHEEL)) {
				if (this.scrollListenerInitialized==null) {
					window.addEventListener("DOMMouseScroll", this.DOMMouseScroll, false);
					this.scrollListenerInitialized = true;
				}
			} else {
				if (this.scrollListenerInitialized!=null) {
					window.removeEventListener("DOMMouseScroll", this.DOMMouseScroll, false);
					this.scrollListenerInitialized = null;
				}			
			}
		},
		/***************************/
		openByGesture : function(launchMode) {
			foxTab.openFoxTab(launchMode);
			this.isOpenByGesture = true;
			if (launchMode == foxTab.LAUNCH_MODE_QUICK) this.isGestureQuickMode = true;
			 else this.isGestureQuickMode = false;
			this.disableMouseClick = true;
		},
		/***************************/
		closeByGesture : function() {
			if (this.isOpenByGesture) {
				foxTab.foxTabWin.foxTabFlash.execute("","closeAndSelect")
				this.isOpenByGesture = false;
				this.isGestureQuickMode = false;
				this.disableMouseClick = false;
			}
		},
		/***************************/
		DOMMouseScroll : function(e) {
			var t = foxTab.mouseGestures;

			allowWheel = false;
			if (((t.MOUSE_GESTURE_CTRL_WHEEL) && (e.ctrlKey)) ||
				((t.MOUSE_GESTURE_RIGHT_WHEEL) && (t.mouseButtonDown==2))){
				allowWheel = true;
			}
			if (allowWheel) {
				 if (foxTab.isFlashOpen) {
					 if (e.target.id!="foxTabFlash") {
					    var mode = foxTab.pref.mode
					    if (foxTab.launchMode==foxTab.LAUNCH_MODE_QUICK) {
						   if (foxTab.pref.quick_mode!="") mode = foxTab.pref.quick_mode
						}
						if (mode-0 == 6) { // check if current mode is Page Flow
							foxTab.foxTabWin.onMouseWheel("k", -1 * e.detail, false)
						} else {
							foxTab.foxTabWin.onMouseWheel("k", -1 * e.detail, true)
						}

						//foxTab.foxTabWin.onMouseWheel("k", -1 * e.detail, true)
					 }
				 } else {		
				     var selectedIndex = foxTab.gBrowser.tabContainer.selectedIndex
					 var numTabs		= foxTab.gBrowser.tabContainer.childNodes.length;
					 if (e.detail<0) selectedIndex    = selectedIndex - 1
					   else selectedIndex    = selectedIndex + 1
					 if (selectedIndex>numTabs-1) selectedIndex = (selectedIndex - numTabs)
					   else if (selectedIndex<0) selectedIndex = numTabs + selectedIndex
					 foxTab.selectedIndex = selectedIndex;


					 t.openByGesture(foxTab.LAUNCH_MODE_QUICK);
					 if ((t.MOUSE_GESTURE_CTRL_WHEEL) && (e.ctrlKey)) window.addEventListener("keyup"  , t.onKeyUp, false);
				 }
				 e.stopPropagation();
				 e.preventDefault();
			}
		},
		/***************************/
		onMouseClick : function(e) {
			var t = foxTab.mouseGestures;
			if ((foxTab.isFlashOpen) && (t.isOpenByGesture)) {
				 e.stopPropagation();
				 e.preventDefault();
				 t.disableMouseClick = false;
			}
		},
		/***************************/
		onMouseDown : function(e) {
			var t = foxTab.mouseGestures;

			if (e.target.ownerDocument=="[object XULDocument]") {
				return false;
			}
			if ((e.target.nodeName.toLowerCase()=="embed") || 
				(e.target.nodeName.toLowerCase()=="object")){
				return false;
			}

			var launch = -1;
			if ((t.screenX==null) || (t.screenY==null)) {
				t.screenX = e.screenX;
				t.screenY = e.screenY;
			} else {
				var delta = 15;
				if ((e.screenX>t.screenX-delta) && (e.screenX<t.screenX+delta) && (e.screenY>t.screenY-delta) && (e.screenY<t.screenY+delta)) {
					if ((t.MOUSE_GESTURE_LEFT_MIDDLE_PRESSED) && (((t.mouseButtonDown==0) && (e.button==1)) || ((t.mouseButtonDown==1) && (e.button==0)))) {
						launch = 0;
					} else if ((t.MOUSE_GESTURE_LEFT_RIGHT_PRESSED) && (((t.mouseButtonDown==0) && (e.button==2)) || ((t.mouseButtonDown==2) && (e.button==0)))) {				
						launch = 1;
					}
				}
				t.screenX = e.screenX;
				t.screenY = e.screenY;
			}
			if (launch!=-1) {
				 if (!foxTab.isFlashOpen) {
					 t.screenX = null;
					 t.screenY = null;
					 t.mouseButtonDown = -1;
					 //if (launch==1) window.addEventListener("contextmenu", t.onContextMenu, true, true)
					 t.openByGesture(foxTab.LAUNCH_MODE_INTERACTIVE);
					 return;
				 }
			}
			t.mouseButtonDown = e.button
		},
		/***************************/
		onMouseUp : function(e) {

			var t = foxTab.mouseGestures;
			if (t.mouseButtonDown!=-1) {
				if ((t.MOUSE_GESTURE_RIGHT_WHEEL) && (t.isGestureQuickMode) && (t.mouseButtonDown==2)) {
					if (foxTab.isFlashOpen) {
						if (e.button==2) t.closeByGesture();
						window.addEventListener("contextmenu", t.onContextMenu, true, true)
					}
				}
				t.mouseButtonDown = -1
			}
			if (!foxTab.isFlashOpen) {
			   if (e.button==2) {
					if ((foxTab.OS==foxTab.MAC) || (foxTab.OS==foxTab.LINUX)) t.displayContextMenu(e);
			   }
			}
		},
		/***************************/
		onContextMenu : function(e) {
			var t = foxTab.mouseGestures;
			if (e.button==2) {
				e.stopPropagation();
				e.preventDefault();
				window.removeEventListener("contextmenu", t.onContextMenu, true, true)
			}
		},
		/***************************/
		// Linux and Mac support
		displayContextMenu : function(e) {

				var evt = e.originalTarget.ownerDocument.createEvent("MouseEvents");
				evt.initMouseEvent(
					"contextmenu", true, true, e.originalTarget.defaultView, 0,
					e.screenX, e.screenY, e.clientX, e.clientY,
					false, false, false, false, 2, null
				);

				foxTab.mouseGestures.disable = true;
				e.originalTarget.dispatchEvent(evt);
		},
		/***************************/
		onLinuxMacContextMenu : function(e) {
			if (foxTab.mouseGestures.disable!=true) {
				var t = foxTab.mouseGestures;
				if (e.button==2) {

					e.stopPropagation();
					e.preventDefault();
				}
			}
			foxTab.mouseGestures.disable = false;				
		},
		/***************************/
		onKeyUp : function(e) {
			var t = foxTab.mouseGestures;

			if ((t.MOUSE_GESTURE_CTRL_WHEEL) && (t.isGestureQuickMode)){
				if (e.keyCode == e.DOM_VK_CONTROL) {
					if (foxTab.isFlashOpen) {
						t.closeByGesture();
						window.removeEventListener("keyup"  , t.onKeyUp, false);
					}
				}
			}
		}
		/***************************/
	},
	/*
	 *
	 */
	onWindowFocus : function() {
		 if (foxTab.isFlashOpen) {
			 if (foxTab.windowFocusInterval!=null) clearTimeout(foxTab.windowFocusInterval)
			 foxTab.windowFocusInterval = setTimeout(foxTab.closeFoxTab,200)
		 }
	},
	/*
	 *
	 */
	checkVersion : function() {
		try{
			  var gExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
									.getService(Components.interfaces.nsIExtensionManager);
			  var currentVersion = gExtensionManager.getItemForID("{ef4e370e-d9f0-4e00-b93e-a4f274cfdd5a}").version;
			
			  var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

			  var foxTabVersion  = ffPreferences.getCharPref("foxTab.version");
			  var isFirstRun	 = ffPreferences.getBoolPref("foxTab.isFirstRun");
		}catch(e){
		    //nothing
		} finally {
			  if (isFirstRun){
				  ffPreferences.setBoolPref("foxTab.isFirstRun",false);
				  ffPreferences.setCharPref("foxTab.version",currentVersion);
			
				  window.setTimeout(function(){
				  foxTab.gBrowser.selectedTab = gBrowser.addTab("http://www.foxtab.com/" + foxTab.VERSION +"/d/");
				  }, 1500);
			  }	else {
				  if (foxTabVersion!=currentVersion){
						ffPreferences.setCharPref("foxTab.version",currentVersion);
						window.setTimeout(function(){
						  foxTab.gBrowser.selectedTab = gBrowser.addTab("http://www.foxtab.com/" + foxTab.VERSION  +"/u/");
						}, 1500);
				  }				
			  }
			  return isFirstRun;
		}
		return false;
	},
	/*
	 *
	 */
	openOptions : function() {
		window.openDialog("chrome://foxtab/content/options/options.xul","FoxTabOptions", "chrome, centerscreen, toolbar");
	},
	/*
	 *
	 */
	setPref : function() {
		  var pref = foxTab.pref
		  var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		  
		  // General
		  pref.siteTitle            = ffPreferences.getBoolPref("foxTab.general.siteTitle");
		  pref.displayFavoriteIcon  = ffPreferences.getBoolPref("foxTab.general.displayFavoriteIcon");
		  pref.closeButton		    = true
		  pref.contextMenu          = ffPreferences.getBoolPref("foxTab.general.contextMenu");
		  pref.disaplyStatusBarIcon = ffPreferences.getBoolPref("foxTab.general.disaplyStatusBarIcon");
		  pref.tabEffect	        = ffPreferences.getBoolPref("foxTab.general.tabEffect");
		  pref.showNavigationArrows = ffPreferences.getBoolPref("foxTab.general.showNavigationArrows");
		  pref.lowMemAlloc			= ffPreferences.getBoolPref("foxTab.system.lowMemAlloc");
		  pref.flashVer			    = ffPreferences.getCharPref("foxTab.general.flashVer");
		  pref.useJPG			    = ffPreferences.getBoolPref("foxTab.general.useJPG");


		  pref.mode			        = ffPreferences.getCharPref("foxTab.mode"); 
		  pref.quick_mode		    = ffPreferences.getCharPref("foxTab.quickMode"); 
		  pref.quick_size		    = ffPreferences.getCharPref("foxTab.view.quickSize");
		  pref.interactive_size	    = ffPreferences.getCharPref("foxTab.view.interactiveSize");

		  // Layout
		  pref.carouselSize        = ffPreferences.getCharPref("foxTab.layout.carouselSize");
		  pref.carouselSize        = 13 - (pref.carouselSize-0)
		  pref.numOfColumns        = ffPreferences.getCharPref("foxTab.layout.numOfColumns");
		  pref.numOfThumbnail      = ffPreferences.getCharPref("foxTab.layout.numOfThumbnail");
		  pref.numOfSlides         = ffPreferences.getCharPref("foxTab.layout.numOfSlides");
		  pref.wallType		       = ffPreferences.getCharPref("foxTab.layout.wallType"); 

		  // 3d Params
		  pref.carouselParams      = ffPreferences.getCharPref("foxTab.layout.carouselParams");
		  pref.rowParams		   = ffPreferences.getCharPref("foxTab.layout.rowParams");
		  pref.slidesParams        = ffPreferences.getCharPref("foxTab.layout.slidesParams");
		  pref.pageFlowParams         = ffPreferences.getCharPref("foxTab.layout.pageFlowParams");
		  pref.wallParams          = ffPreferences.getCharPref("foxTab.layout.wallParams");
		  pref.gridParams          = ffPreferences.getCharPref("foxTab.layout.gridParams");

		  pref.hideTabPanels	   = ffPreferences.getBoolPref("foxTab.general.hideTabPanels");
		  pref.showFirstLaunchHint = ffPreferences.getBoolPref("foxTab.general.showFirstLaunchHint"); 
		 

		  foxTab.canvasType = foxTab.CANVAS_FLOAT
		  if ((pref.quick_size=="fullScreen") || (pref.interactive_size=="fullScreen")){
				foxTab.canvasType = foxTab.CANVAS_WIN
				foxTab.overrideCloseWindow();
		  }

		  if (ffPreferences.getCharPref("foxTab.general.orientation")=="orientationPortrait") {
			  pref.portrait = true
		  } else {
			  pref.portrait = false
		  }

		  pref.multipleWindows         = ffPreferences.getBoolPref("foxTab.general.multipleWindows");
		  pref.closeFoxTabOnTabChange  = true;
		  pref.hideDuplicateTabs       = ffPreferences.getBoolPref("foxTab.general.hideDuplicateTabs");
		  pref.mostRecentlyUsed		   = ffPreferences.getBoolPref("foxTab.general.mostRecentlyUsed");
		  pref.previewBy 	           = ffPreferences.getCharPref("foxTab.general.thumbnailsPreviewBy")
		  pref.thumbnailPreviewByImage = ffPreferences.getBoolPref("foxTab.general.thumbnailByImage")
		  pref.speed		           = ffPreferences.getCharPref("foxTab.visual.animationSpeed");
		  pref.animateLayoutSelection		= ffPreferences.getBoolPref("foxTab.visual.animateLayoutSelection"); 
		  pref.displayPanel					= ffPreferences.getBoolPref("foxTab.visual.displayPanel"); 
		  pref.displayThumbnailsReflection	= ffPreferences.getBoolPref("foxTab.visual.displayThumbnailsReflection"); 
		  pref.hideTheTabBar				= ffPreferences.getBoolPref("foxTab.visual.hideTheTabBar"); 


		  // keyboard
		  pref.keyboardQuick_defaultEnabled = ffPreferences.getBoolPref("foxTab.keyboard.quick.enableDefault");
		  pref.keyboardQuick_customEnabled  = ffPreferences.getBoolPref("foxTab.keyboard.quick.enableCustom");
		  pref.keyboardQuick_customKey	    = ffPreferences.getCharPref("foxTab.keyboard.quick.customKey");
		  pref.keyboardQuick_defaultKey     = 9 // DOM_VK_TAB

		  pref.keyboardInteractive_defaultEnabled = ffPreferences.getBoolPref("foxTab.keyboard.interactive.enableDefault");
		  pref.keyboardInteractive_customEnabled  = ffPreferences.getBoolPref("foxTab.keyboard.interactive.enableCustom");
		  pref.keyboardInteractive_customKey	  = ffPreferences.getCharPref("foxTab.keyboard.interactive.customKey");
		  pref.keyboardInteractive_defaultKey     = 123 // DOM_VK_F12
		 
		  // F8 in Mac
		  if (foxTab.OS==foxTab.MAC) {
		     pref.keyboardInteractive_defaultKey     = 119 // DOM_VK_F8
		  }
			
		  if ((pref.keyboardQuick_customKey!="") && (pref.keyboardQuick_customKey!=null)) {
			  pref.keyboardQuick_customKey = pref.keyboardQuick_customKey.toUpperCase().charCodeAt(0)
		  }
		  if ((pref.keyboardInteractive_customKey!="") && (pref.keyboardInteractive_customKey!=null)) {
			  pref.keyboardInteractive_customKey = pref.keyboardInteractive_customKey.toUpperCase().charCodeAt(0)
		  }
		  pref.firstFlipTabInQuickMode = false;

		  pref.suspensionTime        = ffPreferences.getCharPref("foxTab.keyboard.suspensionTime"); 
		  pref.EnableSuspension      = ffPreferences.getBoolPref("foxTab.keyboard.EnableSuspension"); 
		  if (!pref.EnableSuspension) pref.suspensionTime = 0;
		  
		  pref.quick_mode_threshold	= ffPreferences.getCharPref("foxTab.general.quickModeThreshold")-0;
		  pref.enableTabsThreshold      = ffPreferences.getBoolPref("foxTab.general.enableTabsThreshold"); 
		  if (!pref.enableTabsThreshold) pref.quick_mode_threshold = 2;


		  // Groups and filter
		  pref.sortGroupByName	  = ffPreferences.getBoolPref("foxTab.group.sortByName");
		  pref.searchByTitle      = ffPreferences.getBoolPref("foxTab.find.byTitle");
		  pref.searchByDomain     = ffPreferences.getBoolPref("foxTab.find.byDomain");
		  pref.searchByUrl        = ffPreferences.getBoolPref("foxTab.find.byURL");
		  pref.groupClearFilter	  = ffPreferences.getBoolPref("foxTab.group.clearFilter");
		  pref.findClearFilter	  = ffPreferences.getBoolPref("foxTab.find.clearFilter");
		  pref.groupOpen		  = ffPreferences.getCharPref("foxTab.group.status")-0;
		  pref.filterOpen		  = ffPreferences.getCharPref("foxTab.find.status")-0;

		  // Theme
		  pref.theme		      = ffPreferences.getCharPref("foxTab.theme");	
		  pref.themeColors		  = ffPreferences.getCharPref("foxTab.theme.themeColors");	
		  pref.customColors		  = ffPreferences.getCharPref("foxTab.theme.customColors");
		  pref.useTheme			  = ffPreferences.getCharPref("foxTab.theme.useTheme");	
		  pref.titleColor	      = ffPreferences.getCharPref("foxTab.theme.titleColor");	
		  pref.displayBgImage	  = ffPreferences.getBoolPref("foxTab.theme.displayBgImage");	
		  
		  // Mouse Gesture
		  pref.gestureRightClickScroll = ffPreferences.getBoolPref("foxTab.mouseGesture.rightClickScroll");	
	  	  pref.gestureCtrlScroll	   = ffPreferences.getBoolPref("foxTab.mouseGesture.ctrlScroll");	
		  pref.gestureLeftMiddle	   = ffPreferences.getBoolPref("foxTab.mouseGesture.leftMiddle");	
		  pref.gestureLeftRight	       = ffPreferences.getBoolPref("foxTab.mouseGesture.leftRight");	

		  pref.isFirstLaunch	  = ffPreferences.getBoolPref("foxTab.isFirstLaunch");	

		  try {
			  var show    = document.getElementById("foxTab_contextMenu");
			  show.hidden = !pref.contextMenu
		  } catch (e) {}	
			  
		  try {
			  var foxTab_statusbarpanel    = document.getElementById("foxTab_statusbarpanel");
			  foxTab_statusbarpanel.hidden = !pref.disaplyStatusBarIcon
		  } catch (e) {}			  


		  if (pref.keyboardQuick_defaultEnabled) {
			  foxTab.gBrowser.mTabBox.handleCtrlTab = false
		      foxTab.gBrowser.mTabBox.handleCtrlPageUpDown = false
			  try {
				ffPreferences.setBoolPref("browser.ctrlTab.mostRecentlyUsed", false);
			  } catch (e) {}	
		  } else {
			  foxTab.gBrowser.mTabBox.handleCtrlTab = true
			 foxTab.gBrowser.mTabBox.handleCtrlPageUpDown = true
		  }

		  gBrowser.mTabContainer.collapsed = pref.hideTheTabBar;
	
		  foxTab.mouseGestures.init();
	},
	/*
	 *
	 */
	saveTextFile : function(filePath, text) {
		try {
			netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		} catch (e) {
		}
		var file = Components.classes["@mozilla.org/file/local;1"]
			.createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath( filePath );
		if ( file.exists() == false ) {
			file.create( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420 );
		}
		var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
			.createInstance( Components.interfaces.nsIFileOutputStream );
		outputStream.init( file, 0x04 | 0x08 | 0x20, 420, 0 );
		var output = text

		outputStream.write( output, output.length );
		outputStream.close();
	},
	/*
	 *
	 */
	urlToFileName : function(url_string) {
		url_string = url_string.replace(/\/{1,}/g ,"__")
		url_string = url_string.replace(/:/g ,"~")
		url_string = url_string.replace(/\?/g ,"^")
		url_string = url_string.replace(/&/g ,"_a_")
		url_string = url_string.replace(/\+/g ,"-")
		url_string = url_string.replace(/#/g ,"[]")
		url_string = url_string.replace(/\%/g ,"_[")
		
		if (url_string.length>135) {
			url_string = url_string.substring(0,135);
		}

		if (foxTab.url_to_file_name[url_string]==null) {
			foxTab.url_to_file_name[url_string] = foxTab.windowId+"_"+foxTab.fileNameCounter
			url_string = foxTab.windowId+"_"+foxTab.fileNameCounter 
			foxTab.fileNameCounter++
		} else {
			url_string = foxTab.url_to_file_name[url_string]
		}
	
		return url_string;
	},
	/*
	 *
	 */
	deleteSite : function(url) {
	    var url_string = foxTab.urlToFileName(new String(url))
	    var file = Components.classes["@mozilla.org/file/local;1"]
							.createInstance(Components.interfaces.nsILocalFile);
		try {
			file.initWithPath(foxTab.CACHED_SITE_DIR + url_string + ".");
			file.remove(false);

			file.initWithPath(foxTab.CACHED_SITE_DIR + url_string + "_S.");
			file.remove(false);
		} catch (e) {
		}
	},
	/**
	 *
	 */
	saveCanvas : function(content,canvas, destFile) {
	    var file = Components.classes["@mozilla.org/file/local;1"]
						   .createInstance(Components.interfaces.nsILocalFile);
	    file.initWithPath(destFile);

	    var io = Components.classes["@mozilla.org/network/io-service;1"]
						 .getService(Components.interfaces.nsIIOService);

		try {
			var fileType="image/png";
			if (content.document instanceof ImageDocument)
				fileType="image/jpeg";
			else if (window.screen.width>1280) 
				fileType="image/jpeg";
			else if (foxTab.pref.useJPG) 
				fileType="image/jpeg";			



			var dataURL = io.newURI(canvas.toDataURL(fileType, ""), "UTF8", null);
			var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"]
								  .createInstance(Components.interfaces.nsIWebBrowserPersist);
			persist.persistFlags = Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
			persist.persistFlags |= Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;

			persist.saveURI(dataURL, null, null, null, null, file);
		} catch(e) {

		}
	},
	/**
	 *
	 */
   saveSite : function(content, url, isScreenShot) {
        const MODE_BIG=1;
        const MODE_SMALL=0;
        var fileType = "";
        var canvasBig = foxTab.createCanvas(content,foxTab.BIG_THUMBNAIL_SCALE,MODE_BIG);
        
		var url_string = foxTab.urlToFileName(new String(url))
		foxTab.saveCanvas(content,canvasBig, foxTab.CACHED_SITE_DIR + url_string + "." + fileType)
		var canvasSmall = foxTab.scaleCanvas(canvasBig,0.6);
		foxTab.saveCanvas(content,canvasSmall, foxTab.CACHED_SITE_DIR + url_string + "_S."+fileType)            
		if (foxTab.pref.lowMemAlloc){
			foxTab.resetCanvas(foxTab.canvas);
			foxTab.resetCanvas(foxTab.scaledCanvas);
			foxTab.resetCanvas(foxTab.bufferCanvas);
		}

    },
	resetCanvas : function(canvas){
		canvas.width		= 0;
		canvas.height		= 0;
	},	
    scaleCanvas : function(canvas,scale){
        var canvasW = canvas.width * scale;
        var canvasH = canvas.height * scale;
		
		var scaledCanvas;
		if (foxTab.pref.lowMemAlloc)
			scaledCanvas = foxTab.scaledCanvas;
		else
			scaledCanvas = document.createElementNS( "http://www.w3.org/1999/xhtml", "html:canvas" );
			
        scaledCanvas.style.width  = (canvasW) + "px";
        scaledCanvas.style.height = (canvasH) + "px";
        scaledCanvas.width        = (canvasW);
        scaledCanvas.height        = (canvasH);        
        var ctx = scaledCanvas.getContext("2d");
        ctx.drawImage(canvas,0, 0, canvasW, canvasH);
        return scaledCanvas;
    },
	getThumbnailDimensions: function(scale){
		const MAX_WIDTH=2800;
		var width=Math.floor(screen.width * scale);
		var height;
		if (foxTab.pref.portrait){
			var ratio=5/4;
			if (width>MAX_WIDTH) width = Math.floor(MAX_WIDTH/ratio);
			height = Math.floor(width*ratio);
		}else{
			var ratio=Math.sqrt(2);
			if (width>MAX_WIDTH) width = MAX_WIDTH;
			height=Math.floor(width/ratio);
		}
		return {width:width,height:height};
	},
	/**
	 *
	 */
	createCanvas : function(content,scale,mode) {	
		const AREA_USE	    = "pageScrollPosition";
		const AREA_TOP	    = "pageTopArea";
		const AREA_TOP_LEFT = "pageTopLeftCorner";

		const TOPLEFT_PCT=0.66;
		var bgColor = content.document.bgColor
		if (bgColor=="#000000") {
			try {
				if (content.document.location=="about:blank") bgColor = "#ffffff"
			} catch (e) {}				
		}
		
		if ((bgColor=="") || (bgColor==null)) bgColor = "#ffffff"
		if (foxTab.pref.portrait && mode==0)
			scale*=3/4;



		var area = foxTab.pref.previewBy			
		var p=1;
		if (area == AREA_TOP_LEFT)
			p=TOPLEFT_PCT;
			
		var canvas;
		if (foxTab.pref.lowMemAlloc)
			canvas = foxTab.canvas;
		else
			canvas = document.createElementNS( "http://www.w3.org/1999/xhtml", "html:canvas" );
		
		var thumbDimension = foxTab.getThumbnailDimensions(scale);		
		var canvasW = thumbDimension.width;
		var canvasH = thumbDimension.height;
		
		// canvas resolution is set according to the user screen resolution
		canvas.style.width  = (canvasW) + "px";
		canvas.style.height = (canvasH) + "px";
		canvas.width		= (canvasW);
		canvas.height		= (canvasH);

		var ctx = canvas.getContext("2d");
		ctx.clearRect(0, 0,canvasW,canvasH);

		var isImageContent=(content.document instanceof ImageDocument);
		if (isImageContent){
            iWidth=content.document.images[0].width;
            iHeight=content.document.images[0].height;
            if (iHeight > iWidth){
                var iRatio = iHeight/iWidth;
                canvasW = canvasH / iRatio;
            }else{
                var iRatio = iWidth/iHeight;
                canvasH = canvasW / iRatio;           
            }
            //alert(iWidth+" "+iHeight+" :"+canvasW+" "+canvasH);           
            canvas.style.width  = (canvasW) + "px";
            canvas.style.height = (canvasH) + "px";
            canvas.width        = (canvasW);
            canvas.height        = (canvasH);
                  
            decoderObserver = content.document.imageRequest.decoderObserver;
            ctx.drawImage(decoderObserver,0, 0, canvasW, canvasH);
		}else if (mode==0){
			var contentW=content.scrollMaxX + content.innerWidth;
			var contentH=content.scrollMaxY + content.innerHeight;
			
			var _dx = 0;
			var _dy = 0;
			if (area != AREA_TOP_LEFT){
				_dx=Math.floor((contentW - canvasW/scale)/2);
				if (_dx > 0)
					_dx = 0;
			}
			if (area == AREA_USE) 
				if (content.scrollY){
					_dy = Number(content.scrollY);
					var _maxDy = (contentH - canvasH/scale);
					if (_dy > _maxDy && _maxDy > 0)	
						_dy=_maxDy;
				}
			ctx.scale(scale/p,scale/p);
			ctx.drawWindow(content,_dx,_dy,canvasW/scale*p,canvasH/scale*p, bgColor);			
		}else{
			var w=screen.width;
			var h;
			if (foxTab.pref.portrait){
				h = Math.floor(w*5/4);		
			}else{
				h = Math.floor(w/Math.sqrt(2));
			}
			var contentW=content.scrollMaxX + content.innerWidth;
			var contentH=content.scrollMaxY + content.innerHeight;

			var _dx = 0;
			var _dy = 0;
			if (area != AREA_TOP_LEFT){
				_dx = (contentW - w)/2;
				if (_dx > 0)
					_dx = 0;
			}
			if (area == AREA_USE) 
				if (content.scrollY){
					_dy = Number(content.scrollY);
					var _maxDy = (contentH - h);
					if (_dy > _maxDy && _maxDy > 0)	
					_dy=_maxDy;
				}
			var bufferCanvas;
			if (foxTab.pref.lowMemAlloc)
				bufferCanvas = foxTab.bufferCanvas;
			else
				bufferCanvas = document.createElementNS( "http://www.w3.org/1999/xhtml", "html:canvas" );
			bufferCanvas.style.width  	= w + "px";
			bufferCanvas.style.height 	= h + "px";
			bufferCanvas.width			= w;
			bufferCanvas.height			= h;
			var bufferCtx = bufferCanvas.getContext("2d");
			bufferCtx.clearRect(0, 0,w,h);
			bufferCtx.drawWindow(content,_dx,_dy,w,h, bgColor);
			ctx.drawImage(bufferCanvas, 0, 0, w, h, 0, 0, canvasW/p, canvasH/p);
		}
		return canvas;
	},
	/*
	 *
	 */
	saveTabByBrowser : function(browser, updateImage) {
		try {
			var url = browser.currentURI.spec
			foxTab.saveSite(browser.contentWindow, url)

			if (updateImage!=false) {
				foxTab.updateFoxTabImage(browser, url);
			}
		} catch (e) {
			
		}
	},
	/*
	 *
	 */
	updateFoxTabImage : function(browser, url) {
		if (foxTab.pref.multipleWindows) {
			  var foxTabList = foxTab.getAllFoxTabObjects();
		}else{
			  var foxTabList = new Array(foxTab);
		}
		var f = null
		var index = null;
		for(var j=0; j<foxTabList.length; j++) {
			f = foxTabList[j]
			if (f.isFlashOpen) {
				for(var i=0; i<f.tabsList.length; i++) {
					if (f.tabsList[i].tabBrowser==browser) {
						index = f.tabsList[i].windowIndex;
						break;
					}
				}
				setTimeout(f.foxTabWin.updateImage, 1000, foxTab.windowId, index, foxTab.urlToFileName(new String(url)))
			}
		}
	},
	/*
	 *
	 */
	saveTabByDocument : function(doc) {
		var browser = foxTab.gBrowser.getBrowserForDocument(doc);
	
		if (browser!=null) {
			foxTab.saveTabByBrowser(browser);
		}
		return false;
	},
	/*
	 *
	 */
	onDocumentScroll : function(e) {
		var doc = e.originalTarget;
		var loc = doc.location;
		
		if (doc.interval==null) {
			
		} else {
			clearTimeout(doc.interval);
		}
		doc.interval = setTimeout(foxTab.saveTabByDocument, 4763, doc);
	},
	/*
	 *
	 */
	remotePageLoaded : function(url) {

		var numTabs = foxTab.gBrowser.tabContainer.childNodes.length;
		for(var index=0; index<numTabs; index++) {
			var currentBrowser = foxTab.gBrowser.getBrowserAtIndex(index);
			var url = currentBrowser.currentURI.spec
			if (foxTab.url_allow_list[url]!=null) {
	
				if (currentBrowser.lastURL==null) currentBrowser.lastURL = url

				if ((currentBrowser.isCached==null) || (currentBrowser.lastURL!=url)){
					foxTab.saveSite(currentBrowser.contentWindow, url)
					foxTab.updateFoxTabImage(currentBrowser, url);
					currentBrowser.isCached = true
					if (foxTab.url_list[url]==null) foxTab.url_list[url] = 0
					foxTab.url_list[url]++
				}
				var lastURL = currentBrowser.lastURL
				if (lastURL!=url) {
					if (foxTab.url_list[lastURL]==null) {
						foxTab.url_list[lastURL] = 0
					} else {
						var url_counter =  foxTab.url_list[lastURL]	
						if (url_counter<2) foxTab.deleteSite(lastURL)	
						foxTab.url_list[lastURL]--
						if (url_counter==0) foxTab.url_list[lastURL] = null
					}
				}
				currentBrowser.lastURL=url
			}
			
		}
	},
	/*
	 *
	 */
	onMainButtonPressed : function(e) {
		var allow = true
		if (e!=null) {
			if (e.button != 0) {
				allow = false;
			}
		}
		if (allow) {
			if (!foxTab.isFlashOpen) {
				foxTab.openFoxTab(foxTab.LAUNCH_MODE_INTERACTIVE);
			} else {
				foxTab.closeFoxTab();
			}
		}
	},
	DOMMouseScroll : function(e) {
		if (foxTab.isFlashOpen) {
			 if (e.target.id!="foxTabFlash") {

				var mode = foxTab.pref.mode
				if (foxTab.launchMode==foxTab.LAUNCH_MODE_QUICK) {
				   if (foxTab.pref.quick_mode!="") mode = foxTab.pref.quick_mode
				}
				if (mode-0 == 6) { // check if current mode is Page Flow
					foxTab.foxTabWin.onMouseWheel("k", -1 * e.detail, false)
				} else {
					foxTab.foxTabWin.onMouseWheel("k", -1 * e.detail, true)
				}

				e.stopPropagation();
				e.preventDefault();
			 }
		}
	},
	/*
	 *
	 */
	// this method was added to be used for FireGestures users
	launch : function() {
		foxTab.openFoxTab(foxTab.LAUNCH_MODE_INTERACTIVE);
	},
	/*
	 *
	 */
	openFoxTab : function(launchMode) {

		if (foxTab.foxTabWindow!=null) {
			foxTab.launchMode = launchMode

			foxTab.memHandler.end();

			if (foxTab.launchMode==foxTab.LAUNCH_MODE_INTERACTIVE) {
				if (foxTab.pref.interactive_size!="fitToBrowser") {
					if (foxTab.isDOMMouseScrollRegistered!=true) {
						window.addEventListener("DOMMouseScroll", foxTab.DOMMouseScroll, false);
						foxTab.isDOMMouseScrollRegistered = true;
					}
				}
			}
			var pos = foxTab.calcWindowPosition(); 		

			if (foxTab.canvasType==foxTab.CANVAS_FLOAT) {
				if (foxTab.frameOffScreenTimeout!=null) {
					foxTab.setFoxTabFrame(1);
				} else {
					if (foxTab.displayFrameTimeout!=null) {
						clearTimeout(foxTab.displayFrameTimeout);
						foxTab.displayFrameTimeout = null;
						foxTab.displayFrame();
					}
				}
				if (foxTab.pref.hideTabPanels){
					if (((foxTab.launchMode==foxTab.LAUNCH_MODE_QUICK) && (foxTab.pref.quick_size=="fitToBrowser")) || 
						((foxTab.launchMode==foxTab.LAUNCH_MODE_INTERACTIVE) && (foxTab.pref.interactive_size=="fitToBrowser"))) {
						if (((foxTab.OS!=foxTab.MAC) && (foxTab.OS!=foxTab.LINUX)) || (!foxTab.mouseGestures.isOpenByGesture)) {
							foxTab.gBrowser.mTabBox.tabpanels.style.visibility = "hidden"	
						}
					}
				}
			}

			

			foxTab.moveFrame(foxTab.windowBoxObject.left, foxTab.workAroundHeightDelta);

			foxTab.resizeFrame(foxTab.windowBoxObject.width, foxTab.windowBoxObject.height);

			if (foxTab.canvasType==foxTab.CANVAS_FLOAT) {
				foxTab.foxTabWindow.style.display = ''
			}

			if (foxTab.foxTabWin!=null) {
				foxTab.foxTabWin.onResize();
			}

			if (foxTab.loadOnFirefoxStart) {
				if (foxTab.canvasType!=foxTab.CANVAS_WIN) {
					foxTab.foxTabWindow.contentDocument.getElementById("winBox").style.visibility=""
				} else {
					foxTab.foxTabWindow.document.getElementById("winBox").style.visibility=""
				}

				if (foxTab.isFlashPlayerInstalled) {
					foxTab.foxTabWin.setFlashImages();
				}
				foxTab.isFlashOpen = true;
				foxTab.foxTabWin.foxTabFlash.object.style.width  = foxTab.windowBoxObject.width +"px"
				foxTab.foxTabWin.foxTabFlash.object.style.height = foxTab.windowBoxObject.height +"px"	
				
				if (foxTab.OS==foxTab.MAC) {
					//if(foxTab.windowFocusInterval!=null) clearTimeout(foxTab.windowFocusInterval)
					//foxTab.foxTabWindow.focus();
				} else {
						foxTab.foxTabWindow.focus();
				}
			} else {
			}
		}
	},
	/*
	 *
	 */
	closeFoxTab : function() {

		var f = foxTab
		f.selectedIndex = null;
	
		if (f.loadOnFirefoxStart) {

				if (foxTab.isDOMMouseScrollRegistered==true) {
					window.removeEventListener("DOMMouseScroll", foxTab.DOMMouseScroll, false);
					foxTab.isDOMMouseScrollRegistered = false;
				}			


				if (foxTab.canvasType==foxTab.CANVAS_WIN) {
					if (foxTab.OS==foxTab.LINUX) {
						f.foxTabWindow.resizeTo(1,1);
						if (f.isFlashPlayerInstalled) {
							f.foxTabWindow.foxTabWin.foxTabFlash.execute("","hide_all")
						}
					} else {
						if (f.isFlashPlayerInstalled) {
							f.foxTabWindow.foxTabWin.foxTabFlash.execute("","hide_all")
						}

						if ((f.pref.quick_size=="fitToBrowser") || (f.pref.interactive_size=="fitToBrowser")){ // workaround - we do that because there is a bug of firefox/flash whenever the window is not setted to "fitToBrowser"
																											   // we have to click on the flash in order to have a focus on the flash after we close the window and open it again
							f.foxTabWindow.resizeTo(1,1);
							f.foxTabWindow.moveTo(0,0);
						} else {
							f.foxTabWindow.resizeTo(1,0);
						}
					}
				} else {
						if (foxTab.gBrowser.mTabBox.tabpanels.style.visibility=="hidden") foxTab.gBrowser.mTabBox.tabpanels.style.visibility=""	

						foxTab.moveFrame(-1000,0);
						if (foxTab.canvasType==foxTab.CANVAS_FLOAT) {
							foxTab.resizeFrame(1,1);
						} else {
							foxTab.resizeFrame(1,0);
						}

						if (f.isFlashPlayerInstalled) {
							f.foxTabWin.foxTabFlash.execute("","hide_all")
						}
				}

			f.isQuickLaunch = false;
			f.isFlashOpen = false;
			f.foxTabWin.onFoxTabClosed();
		} else {
			f.foxTabWindow.close();
			f.foxTabWindow = null
			f.isWindowOpen = false;
			f.isFlashOpen = false;
		}
		f.isFlashOpen = false;

		f.memHandler.start();
	},
	memHandler : {

		end : function() {
			var mem = foxTab.memHandler;

			if (mem.refreshWriteTimeOut!=null) clearTimeout(mem.refreshWriteTimeOut);
			if (mem.refreshCleanTimeOut!=null) clearTimeout(mem.refreshCleanTimeOut);
			mem.refreshWriteTimeOut = null;
			mem.refreshCleanTimeOut = null;

			if (mem.isFlashReleased) {
				foxTab.foxTabWin.writeFlash();
				mem.isFlashReleased = false;	
			}
		},
		/*
		 *
		 */
		writeFlash : function() {
			var mem = foxTab.memHandler;
			clearTimeout(mem.refreshWriteTimeOut);
			mem.refreshWriteTimeOut = null;
			if (!foxTab.isFlashOpen) {
				foxTab.foxTabWin.writeFlash();
				mem.isFlashReleased = false;
			}		
		},
		/*
		 *
		 */	
		clearFlash : function () {
			var mem = foxTab.memHandler;
			
			clearTimeout(mem.refreshCleanTimeOut);
			mem.refreshCleanTimeOut = null;
			if (!foxTab.isFlashOpen) {
				if (mem.refreshWriteTimeOut!=null) clearTimeout(mem.refreshWriteTimeOut);
				foxTab.foxTabWin.releaseFlash();
				mem.isFlashReleased = true;
				mem.refreshWriteTimeOut = setTimeout(mem.writeFlash, foxTab.MEM_WRITE_TIME);		
			}
		},
		/*
		 *
		 */	
		start : function () {
			if (foxTab.ENABLE_MEM_HANDLING) {
				if (this.refreshCleanTimeOut!=null) clearTimeout(this.refreshCleanTimeOut);
				this.refreshCleanTimeOut = setTimeout(this.clearFlash, foxTab.MEM_CLEAR_TIME);
			}	
		}

	},
	/*
	 *
	 */
	getInitialWinPosition : function() {
		var pos = foxTab.calcWindowPosition();

		pos.left = 0
		pos.top = 0
		if (foxTab.OS==foxTab.LINUX) {
			pos.width = 2
			pos.height = 2
		} else {
			if (foxTab.canvasType==foxTab.CANVAS_WIN) {
				pos.left = 10000
				pos.top  = 0
				pos.width =  6
				pos.height = 6
			} else {
				pos.width =  1
				pos.height = 1			
			}
		}	
		return pos;
	},
	/*
	 *
	 */
	showWindow : function() {
		var pos = foxTab.getInitialWinPosition();
		
		if (foxTab.canvasType==foxTab.CANVAS_WIN) {
			foxTab.foxTabWindow = window.open(foxTab.WINDOW_CHROME_URL,"foxTab"+foxTab.windowId, "width="+ pos.width +",height="+ pos.height +",top="+ pos.top +",left="+ pos.left +",titlebar=no, chrome, alwaysRaised=yes,dependent,dialog");
			
			function moveWin(left, top) {
				foxTab.foxTabWindow.moveTo(left, top);
			}			
			var win_timeout = setTimeout(moveWin, 1500, -20, 0)
		
		} else {
			var tabsList = document.getElementById("foxTab_tabs_list")
			tabsList.handleCtrlTab = false
		    tabsList.handleCtrlPageUpDown = false


 			var foxTabIframe = document.getElementById("foxTab_iframe")
			foxTabIframe.setAttribute('src', "chrome://foxtab/content/window.xul");
			foxTab.foxTabWindow = foxTabIframe
			if (foxTab.canvasType==foxTab.CANVAS_FLOAT) {
				foxTab.foxTabContainer = document.getElementById("foxTab_iframe_container")
			}
		}

		foxTab.isWindowOpen = true
		if (foxTab.loadOnFirefoxStart) {
			foxTab.isFlashOpen  = false
		} else {
			foxTab.isFlashOpen  = true
		}
	},
	/*
	 *
	 */
	calcWindowPosition : function(forceSize) {
		var f = foxTab

		f.isFirstSizeCalculation = false;

		currentBrowser = f.gBrowser.getBrowserAtIndex(0);

		if (foxTab.canvasType==foxTab.CANVAS_WIN) {
			f.workAroundHeightDelta	  = currentBrowser.boxObject.screenY
			f.windowBoxObject.left    = currentBrowser.boxObject.screenX
			f.windowBoxObject.top     = currentBrowser.boxObject.screenY
		} else {
			f.workAroundHeightDelta	  = currentBrowser.boxObject.y
			f.windowBoxObject.left    = currentBrowser.boxObject.x
			f.windowBoxObject.top     = currentBrowser.boxObject.y
		}
		f.windowBoxObject.width   = currentBrowser.boxObject.width
		f.windowBoxObject.height  = currentBrowser.boxObject.height

		var deltaX = 0
		var deltaY = 0
		


		if (forceSize!=null) {
			var quick_size = forceSize
			var interactive_size = forceSize
		} else {
			//var size = f.pref.size
			var quick_size = f.pref.quick_size
			var interactive_size = f.pref.interactive_size
		}

		topDelta = 0;
		if (foxTab.launchMode==foxTab.LAUNCH_MODE_INTERACTIVE) {
			switch (interactive_size) {
					case "small":
							deltaX = f.windowBoxObject.width*3.6/20;
							deltaY = f.windowBoxObject.height*3.6/20;
						break;
					case "medium":
					case "large":
							deltaX = f.windowBoxObject.width*1/20;
							deltaY = f.windowBoxObject.height*1/20;
						break;
					case "fitToBrowser":
							deltaX = 0;
							deltaY = 0;
					break;
					case "fullScreen":
							deltaX = 0;
							deltaY = 0;
							f.windowBoxObject.left   = 0
							f.windowBoxObject.top    = 0
							f.windowBoxObject.width  = window.screen.width
							f.windowBoxObject.height = window.screen.height

							f.workAroundHeightDelta  = 0
							if (foxTab.OS==foxTab.MAC) {
								deltaY += 20;
								f.windowBoxObject.height += 20;
							}
							if (foxTab.OS==foxTab.LINUX) {
								deltaY += 53;
								f.windowBoxObject.height += 53;
							}
					break;
					default: deltaX = 0;
							 deltaY = 0;
			}	

		} else {
			switch (quick_size) {
					case "small":
							if ((f.pref.mode==1) || (f.pref.mode==2)) {
								deltaX = (f.windowBoxObject.width)  * ((1/20) / (0.3));
								deltaY = (f.windowBoxObject.height) * ((1/4)  / (0.83));
								topDelta = deltaY/5;
							} else {
								deltaX = f.windowBoxObject.width*4/20;
								deltaY = f.windowBoxObject.height*4.5/20;
								topDelta = deltaY/5;
							}
						break;
					case "medium":
					case "large":
							if ((f.pref.mode==1) || (f.pref.mode==2)) {
								deltaX = (f.windowBoxObject.width)  * (1/20)
								deltaY = (f.windowBoxObject.height) * (1/4)
								topDelta = deltaY/5;
							} else {
								deltaX = f.windowBoxObject.width*2/20;
								deltaY = f.windowBoxObject.height*2.6/20;
								topDelta = deltaY/5;
							}
					break;
					case "fitToBrowser":
							deltaX = 0;
							deltaY = 0;
					break;
					case "fullScreen":
							deltaX = 0;
							deltaY = 0;
							f.windowBoxObject.left   = 0
							f.windowBoxObject.top    = 0
							f.windowBoxObject.width  = window.screen.width
							f.windowBoxObject.height = window.screen.height

							f.workAroundHeightDelta  = 0
							if (foxTab.OS==foxTab.MAC) {
								deltaY += 20;
								f.windowBoxObject.height += 20;
							}
							if (foxTab.OS==foxTab.LINUX) {
								deltaY += 53;
								f.windowBoxObject.height += 53;
							}
					break;
					default: deltaX = 0;
							 deltaY = 0;
			}	
		}
		f.windowBoxObject.left   += deltaX
		f.windowBoxObject.top    += deltaY - topDelta
		f.windowBoxObject.width  -= deltaX * 2
		f.windowBoxObject.height -= deltaY * 2

		f.workAroundHeightDelta  += deltaY - topDelta
		return {}
	},

	moveFrame : function(left, top) {
		if (foxTab.canvasType!=foxTab.CANVAS_INNER) {
			if (foxTab.canvasType==foxTab.CANVAS_FLOAT) {
				foxTab.foxTabContainer.style.left = left  +"px"
				foxTab.foxTabContainer.style.top  = top +"px"
			} else {
				foxTab.foxTabWindow.moveTo(left, top);
			}
		}
	},

	resizeFrame : function(width, height) {

		if (foxTab.canvasType==foxTab.CANVAS_WIN) {
			foxTab.foxTabWindow.resizeTo(width, height);
		} else {
			foxTab.foxTabWindow.style.width  =  width + "px"
			foxTab.foxTabWindow.style.height =  height + "px"
		}
	},

	/*
	 *
	 */
	resize : function(forceSize) {
	
		if (foxTab.canvasType!=foxTab.CANVAS_INNER) {
			if (foxTab.isWindowOpen) {
				var pos = foxTab.calcWindowPosition(forceSize); 
				if (foxTab.isFlashOpen) {
					foxTab.moveFrame(foxTab.windowBoxObject.left,foxTab.workAroundHeightDelta);
					foxTab.resizeFrame(foxTab.windowBoxObject.width,foxTab.windowBoxObject.height);
					foxTab.foxTabWin.onResize();
				}
			}
		}
	},
    ////////////////////////////////////////////////
	onResize : function() {
		foxTab.resize();
	},
	moveFrameOffScreen : function() {
		foxTab.moveFrame(-8000,0);
		if (foxTab.frameOffScreenTimeout!=null) clearTimeout(foxTab.frameOffScreenTimeout);
		foxTab.frameOffScreenTimeout = null;
	},
	displayFrame : function() {
		var tabsList = document.getElementById("foxTab_tabs_list")
		tabsList.selectedIndex = "0"
	},
	setFrameNewTab : function() {
		var tabsList = document.getElementById("foxTab_tabs_list")

		var tabpanel = document.createElement("tabpanel");
		var foxTab_tabpanels_element = document.getElementById("foxTab_tabpanels_element")
		foxTab_tabpanels_element.appendChild(tabpanel);

		tabpanel.appendChild(document.getElementById("foxTab_iframe"));
		foxTab_tabpanels_element.removeChild(foxTab_tabpanels_element.childNodes[0])

		tabsList.selectedIndex = "1"
	},

	setFoxTabFrame : function(time) {
		if ((foxTab.pref.hideTabPanels) && (foxTab.isFlashOpen) && (foxTab.launchMode==foxTab.LAUNCH_MODE_INTERACTIVE) && (foxTab.pref.interactive_size=="fitToBrowser")){
				time = null;
		}
		if ((foxTab.OS==foxTab.LINUX) || (foxTab.OS==foxTab.MAC)) {
			if (foxTab.canvasType==foxTab.CANVAS_FLOAT) {
				if (time!=null) {
					foxTab.displayFrameTimeout = setTimeout(foxTab.setFrameNewTab, time)
				} else {
					foxTab.setFrameNewTab();
				}
			}
		} else {
			var tabsList = document.getElementById("foxTab_tabs_list")
			tabsList.selectedIndex = "1"
			if (time!=null) {
				foxTab.displayFrameTimeout = setTimeout(foxTab.displayFrame, time)
			} else {
				tabsList.selectedIndex = "0"
			}			
		}
	},
	/*
	 *
	 */
	onTabOpen : function() {
		foxTab.setFoxTabFrame();

		if (foxTab.isFlashOpen) foxTab.closeFoxTab();
		foxTab.onResize()
	},
	/*
	 *
	 */
	onTabClosed : function(event, browser) {
		
		  if (event==null) {
		  } else {
			 var browser = event.target.linkedBrowser;
		  }

		  var pos = foxTab.mostRecentlyUsedList.indexOf(browser);
		  if (pos>=0) {
				foxTab.mostRecentlyUsedList.splice(pos, 1);
		  }

		  if (foxTab.gBrowser.selectedBrowser==browser) foxTab.disableTabSelected = true

		  if (foxTab.pref.multipleWindows) {
			  var foxTabList = foxTab.getAllFoxTabObjects();
		  } else {
			  var foxTabList = new Array(foxTab);
		  }
		  for(var j=0; j<foxTabList.length; j++) {
			  var f = foxTabList[j];

			  if (f.isFlashOpen) {
				 var index = -1
				 var resultTabsList = new Array();
				 for(var i=0; i<f.tabsList.length; i++) {
					if (f.tabsList[i].tabBrowser==browser) {
						f.tabsList[i].visible = false
						index = i;
					}

					if ((f.tabsList[i].visible) && (!f.tabsList[i].groupFilter)) {
						resultTabsList.push(i);
					}
				 }
				 f.foxTabWin.foxTabFlash.execute("","filterTabs",resultTabsList.join("^"))
				 if (f.foxTabWin.isGroupPanelOpen) {	
					var groupPanelIndex = f.foxTabWin.lastGroupIndex
					var selectedGroupIndex = 0;
					if ((groupPanelIndex!=0) && (groupPanelIndex!=-1)) {
						if (browser.contentDocument) {
							if (browser.contentDocument.domain) {
								var domainName  = f.foxTabWin.getDomainName(browser.contentDocument.domain)
							} else domainName = "Blank"
						} else domainName = "Blank"
						var domainName  = f.foxTabWin.getDomainName(domainName)
						var index = -1
						for(var i=1; i<f.foxTabWin.groupList.length; i++) {
							if (f.foxTabWin.groupList[i].d==domainName) {
							   index = i;
							   break;
							}
						}
						if (index==groupPanelIndex) {
							if (f.foxTabWin.groupList[index].indices.length==1) {
								selectedGroupIndex = 0;
								f.foxTabWin.clearAllFilter();
							} else {
								selectedGroupIndex = groupPanelIndex;
							}
						}
					}
					f.foxTabWin.setGroupPanel(selectedGroupIndex)
					f.foxTabWin.openGroupPanel(false)
				}
			  }
		  }
		  var url = browser.currentURI.spec
		  if (foxTab.url_list[url]==null) {
				foxTab.url_list[url] = 0
		  } else {
				var url_counter =  foxTab.url_list[url]	
				if (url_counter<2) foxTab.deleteSite(url)	
				foxTab.url_list[url]--
				if (url_counter==0) foxTab.url_list[url] = null
		  } 
		  if ((foxTab.OS!=foxTab.LINUX) && (foxTab.OS!=foxTab.MAC)) foxTab.setFoxTabFrame(1);	
	},
	/*
	 *
	 */
	onTabSelected : function(event) {
		
		if (foxTab.disableRecentlyUsedPush) {
			foxTab.disableRecentlyUsedPush = false
		} else {
			var browser = event.target.linkedBrowser;	
			var pos = foxTab.mostRecentlyUsedList.indexOf(browser);
			if (pos>=0) {
				foxTab.mostRecentlyUsedList.splice(pos, 1);
			}
			foxTab.mostRecentlyUsedList.push(browser);
		}

		if (foxTab.disableTabSelected) {
			foxTab.disableTabSelected = false
		} else {
			if ((foxTab.pref.closeFoxTabOnTabChange) && (foxTab.isFlashOpen)) foxTab.closeFoxTab();
		}
		if ((foxTab.OS!=foxTab.LINUX) && (foxTab.OS!=foxTab.MAC)) foxTab.setFoxTabFrame();
	},
	/*
	 *
	 */
	setUrlAsOk : function(url) {
		foxTab.url_allow_list[url] = true
	},
	/*
	 *
	 */
	DOMContentLoaded : function(e) {
		if (foxTab.isFlashPlayerInstalled) {

			var doc = e.originalTarget;
			var loc = doc.location;
			if (e.originalTarget instanceof HTMLDocument) {
				var doc = e.originalTarget;
				if (e.originalTarget.defaultView.frameElement) {
					return;
				}
			}	
			if (foxTab.interval!=null) clearTimeout(foxTab.interval);
			
			var url_interval = setTimeout(foxTab.setUrlAsOk,1000, loc)

			if (foxTab.pref.previewBy=="pageScrollPosition") {
				doc.addEventListener("scroll" , foxTab.onDocumentScroll, false);
			}

			if (doc.interval==null) {
			} else {
				clearTimeout(doc.interval);
			}
			doc.interval = setTimeout(foxTab.saveTabByDocument, 11000, doc); // 12 seconds
			doc.intervalLong = setTimeout(foxTab.saveTabByDocument, 40000, doc); // 40 seconds
			
			// save tab
			foxTab.interval = setTimeout(function(){foxTab.remotePageLoaded(loc)}, foxTab.TIME_CACHE_DELTA);
		}
	},
	/*
	 *
	 */
	closeFirstLaunchHintPanel : function() {
		if (foxTab.hintPanelTimeOut!=null) {
			clearTimeout(foxTab.hintPanelTimeOut);
			foxTab.hintPanelTimeOut = null;
			var panel = document.getElementById("foxTab_firstlaunchPanel");
			if (panel.state=="open") panel.hidePopup();
		}
	},
	/*
	 *
	 */
	openFirstLaunchHintPanel : function() {
		var toolbarIcon = document.getElementById("foxTab_toolbarButton");
		var _left, _top;
		try {
			_left = toolbarIcon.boxObject.x
			_top  = toolbarIcon.boxObject.y
		} catch (e) {
			_left = null;
			_top  = null;
		}	
		if ((_left!=null) && (_top!=null)) {
			if (_top<500) {
				var panel = document.getElementById("foxTab_firstlaunchPanel");
				panel.openPopup(toolbarIcon ,"after_end", 75, 0)
				foxTab.hintPanelTimeOut = setTimeout(foxTab.closeFirstLaunchHintPanel,7000);
			}
		}
	},
	/*
	 *
	 */
	onLoad : function(e) {

		try {
			var urlbar = document.getElementById("urlbar");
			if (urlbar!=null) {
				if (urlbar.readOnly) {
					foxTab.isFoxTabEnabled = false
					document.getElementById("foxTab_contextMenu").hidden = true;
					return false;
				}
			}
		} catch (e) {}
		
		if (foxTab.OS==foxTab.MAC) {
			try {
				document.getElementById("foxTab_toolbarButton").style.cursor = "pointer"
			} catch (e) {}	
		}

		var isToolbarButtonAdded = foxTab.addFoxTabToolbarButton();
		foxTab.gBrowser  = getBrowser()
		foxTab.container = foxTab.gBrowser.tabContainer;

		var gBrowser     = foxTab.gBrowser
		var container    = foxTab.container
		foxTab.setPref();

		var thumbsMaxDimension = foxTab.getThumbnailDimensions(foxTab.BIG_THUMBNAIL_SCALE);
		foxTab.biggestWindowWidth  = thumbsMaxDimension.width;
		foxTab.biggestWindowHeight = thumbsMaxDimension.height;

		if (foxTab.pref.lowMemAlloc){
			var canvasDoc = document.implementation.createDocument('http://www.w3.org/1999/xhtml', 'html', null);
			foxTab.canvas = canvasDoc.createElementNS( "http://www.w3.org/1999/xhtml", "html:canvas" );
			foxTab.scaledCanvas = canvasDoc.createElementNS( "http://www.w3.org/1999/xhtml", "html:canvas" );			
			foxTab.bufferCanvas = canvasDoc.createElementNS( "http://www.w3.org/1999/xhtml", "html:canvas" );			
		}
		
		container.addEventListener("TabOpen" , foxTab.onTabOpen, false);
		container.addEventListener("TabClose", foxTab.onTabClosed, false);
		container.addEventListener("TabSelect", foxTab.onTabSelected, false);
		window.document.addEventListener("DOMContentLoaded", foxTab.DOMContentLoaded, true)
		window.document.addEventListener("FoxTabEvent", foxTab.foxTabListener, false, true);
		
		var isFirstRun = foxTab.checkVersion();
		if ((isToolbarButtonAdded) && (isFirstRun) && (foxTab.pref.showFirstLaunchHint)) {
			setTimeout(foxTab.openFirstLaunchHintPanel,700);
		}

		try {
			var selectedIndex = gBrowser.tabContainer.selectedIndex
			var browser       = gBrowser.getBrowserAtIndex(selectedIndex);
			var pos = foxTab.mostRecentlyUsedList.indexOf(browser);
			if (pos>=0) {
				foxTab.mostRecentlyUsedList.splice(pos, 1);
			}
		} catch (e) {
		}

		if (foxTab.canvasType!=foxTab.CANVAS_WIN) {
			setTimeout(foxTab.launchFoxTabWindow,300);
		} else {
			try {
				var info = Components.classes["@mozilla.org/xre/app-info;1"] .getService(Components.interfaces.nsIXULAppInfo);  
				foxTab.firefoxVer = info.version
				if (info.version>="3.1") { // if firefox version is 3.1 or later
					setTimeout(foxTab.launchFoxTabWindow,1000);
				} else {
					foxTab.launchFoxTabWindow();
				}
			} catch (e) {
				setTimeout(foxTab.launchFoxTabWindow,1000);
			}	
		}
	},
	/*
	 *
	 */
	launchFoxTabWindow : function() {
		if (foxTab.loadOnFirefoxStart) {
			if (!foxTab.isWindowOpen) {
				foxTab.isWindowOpen = true
				foxTab.showWindow();
				setTimeout(foxTab.onResize,2000);
			}
		}	
	},	
	/*
	 *
	 */
	onUnLoad : function() {
		if (foxTab.OS==foxTab.LINUX) {
			foxTab.foxTabWindow.close();
		}
		if (foxTab.OS==foxTab.MAC){
			if (foxTab.isFlashOpen) {
				foxTab.foxTabWindow.close();
			}
		}
		if (foxTab.firefoxVer!=null) {
			if (foxTab.firefoxVer>="3.1") {
				foxTab.foxTabWindow.close();
			}	
		}		

		var numTabs = foxTab.gBrowser.tabContainer.childNodes.length;
		var currentBrowser, url;
		var foxTabList = foxTab.getAllFoxTabObjects();

		for(var i=0; i<numTabs; i++) {
		   currentBrowser = foxTab.gBrowser.getBrowserAtIndex(i);
		   
		   for (var j=0;j<foxTabList.length;j++) {
				if (foxTabList[j].isFlashOpen) {
					foxTabList[j].onTabClosed(null, currentBrowser)
				}
		   }

		   url = currentBrowser.currentURI.spec;
		   if (foxTab.url_list[url]==null) {
				foxTab.url_list[url] = 0
		   } else {
				var url_counter =  foxTab.url_list[url]	
				if (url_counter<2) foxTab.deleteSite(url)	
				foxTab.url_list[url]--
				if (url_counter==0) foxTab.url_list[url] = null
		   } 
		}
	},
	/*
	 *
	 */
	foxTabListener : function(e) {
		  var domainName = e.target.ownerDocument.domain;
		  if ((domainName=="www.foxtab.com") || (domainName=="foxtab.com")) {
			  foxTab.openFoxTab(foxTab.LAUNCH_MODE_INTERACTIVE);
		  }
		  return null;
	},
	/*
	 *
	 */
	getWindowById : function(windowId) {
		  var foxTabList = foxTab.getAllFoxTabObjects();
		  for (var i=0;i<foxTabList.length;i++) {
			  if (foxTabList[i].windowId==windowId) {
			 	return foxTabList[i];
			  }
		  }
		  return null;
	},
	/*
	 *
	 */
	getAllFoxTabObjects : function() {
          var list = new Array();
		  var wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
		  var e = wm.getEnumerator(null);
		
 		  while (e.hasMoreElements()) {
			var w = e.getNext();
			if (w.foxTab!=null) {
				if (w.foxTab.isFoxTabEnabled) list.push(w.foxTab);
			}
		  }
		  return list;
	},
	/*
	 *
	 */
	onCallBack : function() {
	},
	/*
	 *
	 */
	getTabs : function() {

		  var checkDuplicate = function(url) {
				for(var i=0; i<duplicateList.length; i++) {
					if (duplicateList[i]==url) {
						return false;
					}
				}
				duplicateList.push(url);
				return true;
		  }
		  var duplicateList = new Array();


		  var f = foxTab

		  if (f.tabsList!=null) f.tabsList.length = 0;
		  f.tabsList = new Array();

		  if (foxTab.selectedIndex!=null) {
			 selectedIndex = foxTab.selectedIndex
		  } else {
			  if (foxTab.pref.mostRecentlyUsed) {
				  if (f.tabsList.length>1) {
					selectedIndex = 0;
				  } else {
					selectedIndex = 0;
				  }
			  } else {
				 selectedIndex = f.gBrowser.tabContainer.selectedIndex
			  }
		  }
		  if (f.pref.hideDuplicateTabs) {
			   var currentBrowser = f.gBrowser.getBrowserAtIndex(selectedIndex); 
			   var selectedURL = currentBrowser.currentURI.spec
		  }

		  var numTabs		= f.gBrowser.tabContainer.childNodes.length;
		  var url;
		  var blankIndices = ""
		  var args = ""

		  if (foxTab.launchMode==foxTab.LAUNCH_MODE_QUICK) {
			var filterOpen = "0"
			var groupOpen = "0"
			f.foxTabWin.isGroupPanelOpen = false;
			f.foxTabWin.isFilterTextBoxOpen = false;
		  } else {
			var groupOpen  = f.pref.groupOpen
			var filterOpen = f.pref.filterOpen
		  }


		  var tabEffect = f.pref.tabEffect	

		  var mode = f.pref.mode
		  if (foxTab.launchMode==foxTab.LAUNCH_MODE_QUICK) {
			  if (f.pref.quick_size!="fitToBrowser") tabEffect = false
			  if (f.pref.quick_mode!="") var mode = f.pref.quick_mode
		  } else {
			  if (f.pref.interactive_size!="fitToBrowser") tabEffect = false
		  }
		  var prefStr = mode + "|" + tabEffect + "|" + f.pref.numOfSlides + "|" + f.pref.carouselSize + "|" + f.pref.numOfThumbnail+ "|" + f.pref.numOfColumns + "|" + f.pref.wallType+ "|" + 
						groupOpen+ "|" + filterOpen+ "|" + foxTab.pref.portrait+ "|" + f.pref.animateLayoutSelection+ "|" + f.pref.displayPanel+ "|" + f.pref.displayThumbnailsReflection+ "|" + f.pref.closeButton+ "|" + f.pref.speed + "|" + 
						f.pref.carouselParams + "|" + f.pref.rowParams + "|" + f.pref.slidesParams + "|" + f.pref.pageFlowParams + "|" + f.pref.wallParams + "|" + f.pref.gridParams + "|" + foxTab.launchMode + "|" + f.pref.showNavigationArrows+ "|" + f.pref.siteTitle	  


		  args += prefStr+"_^_"

		  args += f.windowBoxObject.width+"_^_"
		  args += f.windowBoxObject.height+"_^_"

		  args += f.biggestWindowWidth+"_^_"
		  args += f.biggestWindowHeight+"_^_"

		  args += "file://" + f.CACHED_SITE_DIR+"_^_"

		  tabsStr = ""
		  if (f.pref.multipleWindows) {
			  var wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
			  var e = wm.getEnumerator(null);
			  var tabsCounter = 0;
			  while (e.hasMoreElements()) {
				var w = e.getNext();
				if (w.foxTab!=null) {
					if (w.foxTab.isFoxTabEnabled) {
						var numTabs		= w.foxTab.gBrowser.tabContainer.childNodes.length;
						if (foxTab.windowId == w.foxTab.windowId) {
							selectedIndex = selectedIndex + tabsCounter
						}
						for(var i=0; i<numTabs; i++) {
						  var currentBrowser = w.foxTab.gBrowser.getBrowserAtIndex(i);
						  if ((!f.pref.hideDuplicateTabs) || (checkDuplicate(currentBrowser.currentURI.spec))) {
						
							  var title = ""
							  if (currentBrowser.contentDocument) {
								if (currentBrowser.contentDocument.title) {
									title = currentBrowser.contentDocument.title;
								}
							  }
							  f.tabsList.push({
												tabBrowser  : currentBrowser,
												tab         : w.foxTab.gBrowser.tabContainer.childNodes[i],
												index       : tabsCounter,
												visible     : true,
												groupFilter : false,
												windowId    : w.foxTab.windowId,
												windowIndex : i,
												title       : title,
												url         : w.foxTab.urlToFileName(currentBrowser.currentURI.spec)
											  });
						  }
						  tabsCounter++
						}
					}

				}
			  }
			  if (foxTab.pref.mostRecentlyUsed) {
				 selectedIndex = 0;
				 if ((tabsCounter>1) && (foxTab.launchMode==foxTab.LAUNCH_MODE_QUICK)){
					selectedIndex = 1;
				 }
			  }
		  } else {
			  for(var i=0; i<numTabs; i++) {
				var currentBrowser = f.gBrowser.getBrowserAtIndex(i);
				if ((!f.pref.hideDuplicateTabs) || (checkDuplicate(currentBrowser.currentURI.spec))) {
				    var title = ""
				    if (currentBrowser.contentDocument) {
					  if (currentBrowser.contentDocument.title) {
					  	  title = currentBrowser.contentDocument.title;
					  }
				    }
					f.tabsList.push({
									  tabBrowser  : currentBrowser,
									  tab         : f.gBrowser.tabContainer.childNodes[i],
									  index       : i,
									  visible     : true,
									  groupFilter : false,
									  windowId    : f.windowId,
									  windowIndex : i,
									  title       : title,
									  url         : f.urlToFileName(currentBrowser.currentURI.spec)
									});
				}
			  }
		  }
		
		  if (f.pref.mostRecentlyUsed) {
			  var currentBrowser = foxTab.gBrowser.selectedBrowser;
			  var pos = foxTab.mostRecentlyUsedList.indexOf(currentBrowser);
			  if (pos>=0) {
				foxTab.mostRecentlyUsedList.splice(pos, 1);
			  }
			  foxTab.mostRecentlyUsedList.push(currentBrowser);

			  var t;
			  for(var i=0; i<f.mostRecentlyUsedList.length; i++) {
				  for(var j=0; j<f.tabsList.length; j++) {
					if (f.tabsList[j].tabBrowser==f.mostRecentlyUsedList[i]) {
					   var t = f.tabsList[j]
					   f.tabsList.splice(j, 1);
					   f.tabsList.unshift(t);					   
					   break;
					}
				  }
			  }
		  }


		  var t;
		  var url;
		  for(var i=0; i<f.tabsList.length; i++) {
			  t = f.tabsList[i]
			  tabsStr += t.windowId+"~"+t.windowIndex+"~"+t.url+"~"+t.title+"_^_"
			  if (t.tabBrowser.currentURI.spec=="about:blank") {
					blankIndices += i+"-"
			  }
		  }

		  if (f.pref.hideDuplicateTabs) {
			  if ((selectedIndex>=duplicateList.length) || (duplicateList[selectedIndex]!=selectedURL)) {
				for(var i=0; i<duplicateList.length; i++) {
					if (duplicateList[i]==selectedURL) {
						selectedIndex = i;
					}
				}
			  }
		  }

		  args += selectedIndex+"_^_"
		  args += tabsStr
		  args += blankIndices+"_^_"

		  return {
				  args          : args,
				  selectedIndex : selectedIndex,
				  numTabs		: numTabs
				 }
	},
	/*
	 *
	 */
	filterTabsByText : function(text) {
		  var f = foxTab

		  var numTabs		= f.gBrowser.tabContainer.childNodes.length;
		  var list = new Array();

		  text = text.toLowerCase();

		  for(var i=0; i<f.tabsList.length; i++) {

				isFound = false

				if ((f.tabsList[i].visible) && (!f.tabsList[i].groupFilter)) {

					var currentBrowser = f.tabsList[i].tabBrowser

					if (f.pref.searchByDomain) {
						if (currentBrowser.contentDocument) {
							if (currentBrowser.contentDocument.domain) {
								_domain = currentBrowser.contentDocument.domain.toLowerCase()
								_domain = _domain.replace("http://",'');
								_domain = _domain.replace("https://",'');
								if (_domain.indexOf(text)!=-1) isFound = true
							}
						}
					} 
					if ((f.pref.searchByTitle) && (!isFound)){
						if (currentBrowser.contentDocument) {
							if (currentBrowser.contentDocument.title) {
								if (currentBrowser.contentDocument.title.toLowerCase().indexOf(text)!=-1) isFound = true
							}
						}
					} 
					if ((f.pref.searchByUrl) && (!isFound)) {
						_url = currentBrowser.currentURI.spec.toLowerCase()
						_url = _url.replace("http://",'');
						_url = _url.replace("https://",'');
						if (_url.indexOf(text)!=-1) isFound = true
					} 
				}
				if (isFound) {
					list.push(i);
				}
		  }	
		  return list;
	},
	/*
	 *
	 */
	addFoxTabToolbarButton : function() {
		var toolbox = document.getElementById("navigator-toolbox");
		var firstInitialization = "foxTabToolbarInitialization"
        if (toolbox.hasAttribute(firstInitialization)) {
            return false;
        }
		var hasFoxTabButton = false;
		for (var i = 0; i < toolbox.childNodes.length; ++i) {
		  var toolbar = toolbox.childNodes[i];
		  if (toolbar.localName == "toolbar" && toolbar.getAttribute("customizable") == "true" ) {
			if (toolbar.currentSet.indexOf("foxTab_toolbarButton") > -1)
			  hasFoxTabButton = true;
		  }
		}
		var isAdded = false;
		if (!hasFoxTabButton) {
		  for (var i = 0; i < toolbox.childNodes.length; ++i) {
			toolbar = toolbox.childNodes[i];
			if (toolbar.localName == "toolbar" &&  toolbar.getAttribute("customizable") == "true"
			  && toolbar.id == "nav-bar") {
			  var newSet = "";
			  var child = toolbar.firstChild;
			  while (child) {
				if(child.id == "urlbar-container") {
					newSet += "foxTab_toolbarButton,";
					isAdded = true;
				}
				newSet += child.id + ",";
				child = child.nextSibling;
		  	  }
			  if (!isAdded) newSet += "foxTab_toolbarButton,";

			  newSet = newSet.substring(0, newSet.length-1);
			  toolbar.currentSet = newSet;
			  toolbar.setAttribute("currentset", newSet);
			  toolbox.ownerDocument.persist(toolbar.id, "currentset");
			  BrowserToolboxCustomizeDone(true)
			  break;
			}
		  }
		}
		try {
			toolbox.setAttribute(firstInitialization, "initialized");
			toolbox.ownerDocument.persist(toolbox.id, firstInitialization);
			return isAdded;
		} catch (e) {
			return false;
		}
	},
	/*
	 *
	 */
	isQuickLaunchAllowed : function(isQuickLaunch) {
		var f = foxTab;
		if (isQuickLaunch) {
			if (f.pref.quick_mode_threshold<=2) {
			  if (f.pref.keyboardQuick_defaultEnabled) {
				  foxTab.gBrowser.mTabBox.handleCtrlTab = false
				  foxTab.gBrowser.mTabBox.handleCtrlPageUpDown = false
			  }
			  return true;
			} else {
			  if (f.pref.multipleWindows) {
				  var wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
				  var e = wm.getEnumerator(null);
				  var tabsCounter = 0;
				  while (e.hasMoreElements()) {
					var w = e.getNext();
					if (w.foxTab!=null) {
						if (w.foxTab.isFoxTabEnabled) tabsCounter += w.foxTab.gBrowser.tabContainer.childNodes.length;
					}
				  }
			  } else {
				   var tabsCounter	= f.gBrowser.tabContainer.childNodes.length;
			  }

			  if (f.pref.quick_mode_threshold>tabsCounter) {
				  foxTab.gBrowser.mTabBox.handleCtrlTab = true
		          foxTab.gBrowser.mTabBox.handleCtrlPageUpDown = true
				  return false;
			  } else {
				  if (f.pref.keyboardQuick_defaultEnabled) {
					  foxTab.gBrowser.mTabBox.handleCtrlTab = false
					  foxTab.gBrowser.mTabBox.handleCtrlPageUpDown = false
				  }
				  return true;
			  }
			}
		}
		return true;
	},
	/*
	 *
	 */
	openFoxTabByKey : function(isForward) {
		clearInterval(foxTab.keyboardInterval)
		foxTab.keyboardInterval = null;

		var steps = foxTab.steps 
		foxTab.steps = 0;
		var selectedIndex = foxTab.gBrowser.tabContainer.selectedIndex
		var numTabs		= foxTab.gBrowser.tabContainer.childNodes.length;
		
		var foxTabSelectedIndex;
		if (foxTab.isKeyDown) {
				if ((foxTab.pref.mostRecentlyUsed) && (foxTab.mostRecentlyUsedList.length>1)){
					  foxTabSelectedIndex = 0;
					  if (foxTab.isQuickLaunch) {
						  var t;
						  var contentDocument = foxTab.mostRecentlyUsedList[foxTab.mostRecentlyUsedList.length-2].contentDocument
						  if (foxTab.pref.multipleWindows) {
							  var foxTabList = foxTab.getAllFoxTabObjects();
						  } else {
							  var foxTabList = new Array(foxTab);
						  }
						  for(var j=0; j<foxTabList.length; j++) {
							 var docIndex = foxTab.gBrowser.getBrowserIndexForDocument(contentDocument);
							 if (docIndex!=-1) {
								selectedIndex = docIndex
								foxTabSelectedIndex = 1
								break;
							 }
						  }	
						  foxTab.swapLast2Recently = true
					  } else {
						
					  }
				} else {
					if (foxTab.isQuickLaunch) {
						selectedIndex 		 = selectedIndex + steps
						if (selectedIndex>numTabs-1) selectedIndex = (selectedIndex - numTabs)
						  else if (selectedIndex<0) selectedIndex = numTabs + selectedIndex
					}
					foxTabSelectedIndex = selectedIndex
				}

				foxTab.selectedIndex = foxTabSelectedIndex
				if (foxTab.isQuickLaunch) {
					foxTab.openFoxTab(foxTab.LAUNCH_MODE_QUICK);
				} else {
					foxTab.openFoxTab(foxTab.LAUNCH_MODE_INTERACTIVE);
				}
				if (foxTab.pref.firstFlipTabInQuickMode) {
					if (foxTab.gBrowser.tabContainer.selectedIndex!= selectedIndex) {
						foxTab.disableTabSelected = true
						foxTab.disableRecentlyUsedPush = true
						foxTab.gBrowser.tabContainer.selectedIndex = selectedIndex		
					}
				}
		} else {
				if ((foxTab.pref.mostRecentlyUsed) && (foxTab.mostRecentlyUsedList.length>1)){
					  var t;
					  var contentDocument = foxTab.mostRecentlyUsedList[foxTab.mostRecentlyUsedList.length-2].contentDocument
					  if (foxTab.pref.multipleWindows) {
						  var foxTabList = foxTab.getAllFoxTabObjects();
					  } else {
						  var foxTabList = new Array(foxTab);
					  }
					  for(var j=0; j<foxTabList.length; j++) {
						 var docIndex = foxTab.gBrowser.getBrowserIndexForDocument(contentDocument);
						 if (docIndex!=-1) {
							selectedIndex = docIndex
							break;
						 }
					  }
			    } else {

					selectedIndex 		 = selectedIndex + steps
					if (selectedIndex>numTabs-1) selectedIndex = (selectedIndex - numTabs)
					   else if (selectedIndex<0) selectedIndex = numTabs + selectedIndex
				}
				if (foxTab.gBrowser.tabContainer.selectedIndex!= selectedIndex) {
					foxTab.disableTabSelected = true
					foxTab.gBrowser.tabContainer.selectedIndex = selectedIndex		
				}
		}

	},
	/*
	 *
	 */
	onKeyDown : function(event) {

		var p = foxTab.pref

		var isLaunchKey_Quick = false
		var isLaunchKey_Interactive = false
		var forceCtrl = true;
		if ((event.keyCode==p.keyboardQuick_defaultKey) || 
			(event.keyCode==event.DOM_VK_PAGE_UP) ||
			(event.keyCode==event.DOM_VK_PAGE_DOWN)) {
		    if (p.keyboardQuick_defaultEnabled) isLaunchKey_Quick = true;

		} else if (event.keyCode==p.keyboardQuick_customKey) {
		    if (p.keyboardQuick_customEnabled) isLaunchKey_Quick = true;
		
		} else if (event.keyCode==p.keyboardInteractive_defaultKey) {
		    if (p.keyboardInteractive_defaultEnabled) {
				isLaunchKey_Interactive = true;
				forceCtrl = false;
			}
		
		} else if (event.keyCode==p.keyboardInteractive_customKey) {
		    if (p.keyboardInteractive_customEnabled) isLaunchKey_Interactive = true;
		}

		if ((event.ctrlKey) && (event.keyCode == event.DOM_VK_F4)) {
			if (!foxTab.gBrowser.mTabBox.handleCtrlPageUpDown) {
				foxTab.gBrowser.removeCurrentTab();
				return false;
			}
		}

			if ((isLaunchKey_Quick) || (isLaunchKey_Interactive)) {
			  if (((event.ctrlKey) || (!forceCtrl)) && (!event.altKey) && (!event.metaKey)) {

				if ((!foxTab.isWindowOpen) || ((foxTab.loadOnFirefoxStart) && (!foxTab.isFlashOpen))) {
					foxTab.isKeyDown = true
					
					if ((isLaunchKey_Quick) && (!foxTab.isQuickLaunchAllowed(isLaunchKey_Quick))) return;
					foxTab.isQuickLaunch = isLaunchKey_Quick

					if (foxTab.keyboardInterval==null) {
						foxTab.steps = 0;
					}

					if ((event.shiftKey) || (event.keyCode==event.DOM_VK_PAGE_UP)) {
						foxTab.steps = -1
						isForward = false
					} else {
						foxTab.steps = 1
						isForward = true
					}
						
					if ((foxTab.pref.suspensionTime-0==0) || (isLaunchKey_Interactive)) {
						foxTab.openFoxTabByKey(isForward);
					} else {
						clearTimeout(foxTab.keyboardInterval)
						foxTab.keyboardInterval = setTimeout(foxTab.openFoxTabByKey, foxTab.pref.suspensionTime-0, isForward)
					}

				} else {
					if ((event.keyCode==p.keyboardInteractive_defaultKey) && (p.keyboardInteractive_defaultEnabled)) {
						if (foxTab.isFlashOpen) {
							foxTab.closeFoxTab();
						}
					 } else {
						if (event.shiftKey || (event.keyCode==event.DOM_VK_PAGE_UP)) {
							foxTab.foxTabWin.onMouseWheel("k", 5, true)
						} else {
							foxTab.foxTabWin.onMouseWheel("k", -5, true)
						}
					}
				}
				event.stopPropagation();
				event.preventDefault();
			} else {
				if (foxTab.isFlashOpen) {
					switch (event.keyCode) {
						case event.DOM_VK_TAB:
							if (event.shiftKey) {
								foxTab.foxTabWin.onMouseWheel("k", 5, true);
							} else {
								foxTab.foxTabWin.onMouseWheel("k", -5, true);
							}
						break;
						case event.DOM_VK_PAGE_UP:
							foxTab.foxTabWin.onMouseWheel("k", 5, true);
						break;
						case event.DOM_VK_PAGE_DOWN:
							foxTab.foxTabWin.onMouseWheel("k", -5, true);
						break;
					}
				}

			}
		} else {
			if (foxTab.isFlashOpen) {
				switch (event.keyCode) {
					case 70:
						if (event.ctrlKey) {
							if (!foxTab.foxTabWin.isFilterTextBoxOpen) {	
								foxTab.foxTabWin.openSearchPanel();
							} else {
								foxTab.foxTabWin.closeSearchPanel();
							}
							event.stopPropagation();
							event.preventDefault();
						}
					break;
					case 71: 
						if (event.ctrlKey) {
							if (!foxTab.foxTabWin.isGroupPanelOpen) {		
								foxTab.foxTabWin.setGroupPanel();
								foxTab.foxTabWin.openGroupPanel(true);
							} else {
								foxTab.foxTabWin.closeGroupPanel();
								
							}
							event.stopPropagation();
							event.preventDefault();
						}
					break;
					case event.DOM_VK_ESCAPE:
						foxTab.closeFoxTab();
					break;
					case event.DOM_VK_TAB:
						if (event.shiftKey) {
							foxTab.foxTabWin.onMouseWheel("k", 5, true);
						} else {
							foxTab.foxTabWin.onMouseWheel("k", -5, true);
						}
					break;
					case event.DOM_VK_PAGE_UP:
						foxTab.foxTabWin.onMouseWheel("k", 5, true);
					break;
					case event.DOM_VK_PAGE_DOWN:
						foxTab.foxTabWin.onMouseWheel("k", -5, true);
					break;
					case event.DOM_VK_DOWN:
						foxTab.foxTabWin.onMouseWheel("k", -5, false);
					break;
					case event.DOM_VK_RIGHT:
						foxTab.foxTabWin.onMouseWheel("k", -5, true);
					break;
					case event.DOM_VK_UP:
						foxTab.foxTabWin.onMouseWheel("k", 5, false)
					break;
					case event.DOM_VK_LEFT:
						foxTab.foxTabWin.onMouseWheel("k", 5, true);
					break;
					case event.DOM_VK_RETURN:
						foxTab.foxTabWin.foxTabFlash.execute("","closeAndSelect");
					break;
					case event.DOM_VK_SPACE:
						if (!foxTab.foxTabWin.isFilterTextBoxOpen) {	
							foxTab.foxTabWin.foxTabFlash.execute("","closeAndSelect")
				    	}
					break;
				}
			}
		}
	},
	/*
	 *
	 */
	onKeyUp : function(event) {

		if (foxTab.canvasType==foxTab.CANVAS_WIN) {
			if (foxTab.mouseGestures.isOpenByGesture) {
				foxTab.mouseGestures.onKeyUp(event)
			}
		}


		if (event.keyCode == event.DOM_VK_CONTROL) {
			foxTab.isKeyDown = false
		}
		if (foxTab.isQuickLaunch) {
			if (foxTab.isFlashPlayerInstalled) {
				if (foxTab.isFlashOpen) {
					if (event.keyCode == event.DOM_VK_CONTROL) {
						foxTab.foxTabWin.foxTabFlash.execute("","closeAndSelect")
						event.stopPropagation();
						event.preventDefault();
					}
				} else {
					if (event.keyCode == event.DOM_VK_CONTROL){
						if (foxTab.keyboardInterval!=null) {
							foxTab.isKeyDown = false
							clearTimeout(foxTab.keyboardInterval)
							foxTab.openFoxTabByKey(true);
						}
					} else {
					}
				}
			}
		}
	},
	/*
	 *
	 */
	startCheckCallBack : function() {
		var interval = setTimeout(foxTab.checkCallBack,50)
	},
	/*
	 *
	 */
	checkCallBack : function() {
		 if (foxTab.foxTabWin.foxTabFlash==null) {
			 var interval = setTimeout(foxTab.checkCallBack,10)	
		 } else {
			 foxTab.foxTabWin.checkCallBack();
		 }
	},
	overrideCloseWindow : function() { 
		if (foxTab.canvasType==foxTab.CANVAS_WIN) {
			window.closeWindow = function(aClose, aPromptFunction) {
					var windowCount = 0;
					var wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
					var e = wm.getEnumerator(null);

					foxTabCounter = 0;
					while (e.hasMoreElements()) {
						var w = e.getNext();
						windowCount++
						if (w.foxTab!=null) {
							if (w.foxTab.isFoxTabEnabled) {
								foxTabCounter++
							}
						}
					}
					if (foxTab.canvasType==foxTab.CANVAS_WIN) {
						windowCount -= foxTabCounter
					}

					if (windowCount == 1 && !canQuitApplication()) {
						return false;
					} else if (windowCount != 1) {
						if (typeof aPromptFunction == "function" && !aPromptFunction()) {
							return false;
						}
					}
					if (aClose) {
						window.close();
					}
					return true;
			}
		}
	},
	/*
	 *
	 */
	flashBlockEvent : function(e) { 
		if (e.target.location==foxTab.WINDOW_CHROME_URL) {
			e.preventDefault();
			e.stopPropagation();
		}
	},
	/*
	 *
	 */
	openAdobeFlashPlayerSite : function() { 
		foxTab.closeFoxTab();
		foxTab.gBrowser.selectedTab = foxTab.gBrowser.addTab("http://get.adobe.com/flashplayer/")		
	}
}

foxTab.init();
