/* Copyright (c) 2009, Roi M. (foxtab@gmail.com)
 * All rights reserved.
 * See License.txt for further details.
 */
var foxTabWin = {

	selectedIndex   : null,
	numTabs		    : null,
	wo			    : null,
	wp			    : null,

	foxTabFlash  	: new FoxTab_Flash(),
		
	flashCallBack   : 0,
 
	windowPositionInterval : null,
	lastWindowX		: 0,
	lastWindowY		: 0,
	isFilterTextBoxOpen : false,
	isGroupPanelOpen : false,
	

	isFullScreen   : false,
	filterInterval : null,
	groupList      : null,
	lastGroupIndex : -1,
	/*
	 *
	 */
	init : function() {
		if (window.parent) {
			if (window.parent.foxTab) {
				foxTabWin.wo = window.parent.foxTab;
				foxTabWin.wp = window.parent;
			} else {
				foxTabWin.wo = window.opener.foxTab;
				foxTabWin.wp = window.opener;			
			}
		} else {
			foxTabWin.wo = window.opener.foxTab;
			foxTabWin.wp = window.opener;
		}
		if (foxTabWin.wp==window.opener) {
			function blurWindow() {
				window.blur()
			}			
			var win_timeout = setTimeout(blurWindow, 1)
			window.addEventListener("keyup"  , foxTabWin.wo.onKeyUp, false);
			window.addEventListener("keydown", foxTabWin.wo.onKeyDown, false);
		}
		window.addEventListener("load", foxTabWin.onLoad, false);
		window.addEventListener("flashblockCheckLoad", foxTabWin.flashBlockEvent, true, true);
	},
	/*
	 *
	 */
	onMouseWheel : function(evt,args, isKey) {
		var f = foxTabWin
		if (args>0) {
			f.selectedIndex--
			if (f.selectedIndex<0) f.selectedIndex = f.numTabs-1
		} else {
			f.selectedIndex++
			if (f.selectedIndex>f.numTabs-1) f.selectedIndex = 0
		}

		f.foxTabFlash.execute("","onJSMouseWheel",args, isKey)
	},
	/*
	 *
	 */
	onImageCorrupted : function(evt,args) {
		 var params = args.split("_");
		 var foxTabObject = foxTabWin.wo.getWindowById(params[0]-0);

		 if (foxTabObject!=null) {
			 if (foxTabObject.OS!=foxTabObject.MAC) {
				foxTabObject.saveTabByBrowser(foxTabWin.wo.tabsList[params[2]].tabBrowser, false);
			 }
			 foxTabWin.foxTabFlash.execute("","loadFixedImage",params[2], params[3])	
		 }
	},
	/*
	 *
	 */
	onTabSelected : function(evt,args) {
		 var params = args.split("_");
		 var foxTabObject = foxTabWin.wo.getWindowById(params[0]);
		 if (foxTabObject!=null) {
			 foxTabWin.closeFoxTab();
			 var b = foxTabObject.gBrowser
			 b.selectedTab = foxTabWin.wo.tabsList[params[2]].tab
			 if (foxTabObject!=foxTabWin.wo) foxTabObject.win.focus();
		 }
	},
	/*
	 *
	 */
	updateImage : function(windowId, tabIndex, newUrl) {
	    if (!foxTabWin.wo.pref.multipleWindows) windowId = -1
		foxTabWin.foxTabFlash.execute("","updateImage", windowId, tabIndex, newUrl)
	},
	/*
	 *
	 */
	setTextPosition : function(posX, posY, windowId, windowIndex, tabIndex) {
		if (foxTabWin.rightPanelOpen==true) return false;
	    var div = document.getElementById("foxTab_div_text")
	    div.style.display = ""
	    if ((posY<35) && (foxTabWin.wo.launchMode!=foxTabWin.wo.LAUNCH_MODE_QUICK)) posY = 35
	    div.style.top  = posY +"px"
	    div.style.color = "#ffffff"
	    var font = document.getElementById("foxTab_siteTitle")

	    var currentBrowser = foxTabWin.wo.tabsList[tabIndex].tabBrowser

	    try {
		   var favIconObj = null

		   var title = currentBrowser.contentDocument.title
		   if (title=="") {
				if (currentBrowser.currentURI.spec=="about:blank") title="Blank Page"
		   } else {
			   if (foxTabWin.wo.pref.displayFavoriteIcon) {
					var pageDomain = currentBrowser.contentDocument.domain
					favIconObj = document.createElement("image");
					favIconObj.setAttribute("src", "http://"+pageDomain +"/favicon.ico");
					favIconObj.setAttribute("validate","never")
					favIconObj.setAttribute("width","16")
					favIconObj.setAttribute("height","16")
					favIconObj.style.marginRight = "7px"			   
			   }
			   
		   }
		   font.style.color = "#" + foxTabWin.wo.pref.titleColor
		   font.style.fontFamily = "arial"

		   var isSmallSize = false;
		   if (((foxTabWin.wo.launchMode==foxTabWin.wo.LAUNCH_MODE_INTERACTIVE) && (foxTabWin.wo.pref.interactive_size=="small")) ||
			  ((foxTabWin.wo.launchMode==foxTabWin.wo.LAUNCH_MODE_QUICK) && (foxTabWin.wo.pref.quick_size=="small"))) {
			  isSmallSize = true;
		   }
		   if (isSmallSize) {
				font.style.fontSize = "20px"
				if (title.length>45) title = title.substring(0,45)+"..."
		   } else {
			    if (title.length>65) title = title.substring(0,65)+"..."
				font.style.fontSize = "25px"
		   }

		   font.innerHTML = ""
		   if (favIconObj!=null) font.appendChild(favIconObj);
		   var nobr = document.createElement("html:nobr");
		   nobr.textContent = title
		   font.appendChild(nobr);

	    } catch (e) {
		}	   
	},
	/*
	 *
	 */
	onGroupItemDbClick : function (index) {
		if (!isNaN(index)) {
			if (foxTabWin.groupList[index].indices.length==1) {
				foxTabWin.foxTabFlash.execute("","closeAndSelect")
			}
		}
	},
	/*
	 *
	 */
	onGroupItemClick : function (index) {
	   var f = foxTabWin

		var list = new Array();
	    var tabsList = foxTabWin.wo.tabsList
		if (index-0!=0) {
			for (var i=1;i<f.groupList.length;i++) {
				if (i!=(index-0)) {
					 for (var j=0;j<f.groupList[i].indices.length;j++) {
						tabsList[f.groupList[i].indices[j]].groupFilter = true;
					 }
				}
			}
		}
		if (!isNaN(index)) {
			for (var j=0;j<f.groupList[index].indices.length;j++) {
				if (tabsList[f.groupList[index].indices[j]].visible) {
					list.push(f.groupList[index].indices[j])
					tabsList[f.groupList[index].indices[j]].groupFilter = false;
				} else {
					tabsList[f.groupList[index].indices[j]].groupFilter = true;
				}
			}
		}
		list.sort(function(a, b){return (a - b)})
		if (f.lastGroupIndex!=-1) {
			document.getElementById("groups_arrow" + f.lastGroupIndex).src = 'chrome://foxtab/skin/images/groupsPanel/green_arrow.png'
		}
		document.getElementById("groups_arrow" + index).src = 'chrome://foxtab/skin/images/groupsPanel/blue_arrow.png'
		f.lastGroupIndex = index

		// Clear the filter text
	    var textbox = document.getElementById("foxTab_filter_textbox")
	    textbox.value = ""
	    textbox.style.color = "#" + foxTabWin.wo.pref.titleColor

		foxTabWin.foxTabFlash.execute("","filterTabs",list.join("^"))
	},
	/*
	 *
	 */
	getDomainName : function(domainName) {
		var tldList = new Array("com","net","org","us","uk","de","ws","int", "mob","biz","info","net","edu","mil","nom","sch","tv","ac","k12","muni")
		var sldList = new Array("co","com","org","net","edu","mil","nom","sch","tv","ac","k12","muni")
		var domainSplit = domainName.split(".");
		
		if (domainSplit.length>2) {
			tld = domainSplit[domainSplit.length-1].toLowerCase();
			sld = domainSplit[domainSplit.length-2].toLowerCase();
			for (var i=0;i<sldList.length;i++) {
				if (sldList[i]==sld) {
					return domainSplit[domainSplit.length-3]+"."+domainSplit[domainSplit.length-2]+"."+domainSplit[domainSplit.length-1];
				}
			}
			for (var i=0;i<tldList.length;i++) {
				if (tldList[i]==tld) {
					return domainSplit[domainSplit.length-2]+"."+domainSplit[domainSplit.length-1];
				}
			}

			if (domainSplit[0]=="www") {
				domainName = domainSplit[1]
				for (var i=2;i<domainSplit.length;i++) {
					domainName += "."+ domainSplit[i]
				}
				return domainName;
			} else {
				if (domainSplit.length==3) {
				  domainName = domainSplit[domainSplit.length-2]+"."+domainSplit[domainSplit.length-1]
				}
				return domainName;
			}
		} else {
			return domainName;
		}
		return domainName;
	},
	/*
	 *
	 */
	openGroupPanel : function(animate) {
	   var div = document.getElementById("foxTab_div_groups_panel")
	   if (animate) {
		   t1 = new FoxTab_Tween(div.style,'left',false,parseFloat(div.style.left),5,0.6,'px');
		   t1.start();
		   t1.onMotionFinished = function(){
			foxTabWin.foxTabFlash.execute("","groupPanelOpened")
		   };
	   } else {
		   div.style.left = "5px"
	   }
	   if (foxTabWin.wo.OS==foxTabWin.wo.LINUX) {
	     var bg_iframe = document.getElementById("foxTab_iframe_groups") // only linux
	     if (animate) {
			   t2 = new FoxTab_Tween(bg_iframe.style,'left',false,parseFloat(bg_iframe.style.left),5,0.6,'px');
			   t2.start();
		  } else {
		     bg_iframe.style.left = "5px"
		  }	   
	   }
	   foxTabWin.isGroupPanelOpen = true;
	},
	/*
	 *
	 */
	closeGroupPanel : function() {
	   var div = document.getElementById("foxTab_div_groups_panel")
	   t1 = new FoxTab_Tween(div.style,'left',true,parseFloat(div.style.left),-255,0.6,'px');
	   t1.start();
	   t1.onMotionFinished = function(){
			if (foxTabWin.wo.pref.groupClearFilter) foxTabWin.clearAllFilter();
			foxTabWin.foxTabFlash.execute("","groupPanelClosed")
	   };
	   if (foxTabWin.wo.OS==foxTabWin.wo.LINUX) {
			var bg_iframe = document.getElementById("foxTab_iframe_groups") // only linux
			t2 = new FoxTab_Tween(bg_iframe.style,'left',true,parseFloat(bg_iframe.style.left),-255,0.6,'px');
	  	    t2.start();	   
	   }   
	   foxTabWin.isGroupPanelOpen = false;
	},
	/*
	 *
	 */
	clearAllFilter : function() {
		var tabsList = foxTabWin.wo.tabsList
		var list = new Array();
		for(var i=0; i<tabsList.length; i++) {
			if (tabsList[i].visible) {
				tabsList[i].groupFilter = false
				list.push(i);
			}
		}
		var textbox = document.getElementById("foxTab_filter_textbox")
		textbox.value = ""
		textbox.style.color = "#" + foxTabWin.wo.pref.titleColor
		foxTabWin.foxTabFlash.execute("","filterTabs",list.join("^"))
	},
	/*
	 *
	 */
	onGroupPanelScroll : function(evt) {
			if (foxTabWin.groupParams!=null) {
				 if (evt.detail>0) {
					 foxTabWin.groupScroll(15, true);
				 } else {
					 foxTabWin.groupScroll(-15, true);
				 }
			} else {
				foxTabWin.foxTabFlash.onMouseWheel(evt);
			}
	},
	/*
	 *
	 */
	groupScrollUp : function() {
		foxTabWin.groupScroll(-15);
	},
	/*
	 *
	 */
	groupScrollDown : function() {
		foxTabWin.groupScroll(15);
	},
	/*
	 *
	 */
	groupScroll : function(delta, disableTween) {
		var g = foxTabWin.groupParams

		var groupScrollDiv = document.getElementById("groupScrollDiv")
		var scrollDivTop = parseFloat(groupScrollDiv.style.top);
		scrollDivTop += delta
		if (scrollDivTop<0) scrollDivTop = 0;
		 else if (scrollDivTop>g.scrollHeight - g.scrollDivHeight-2) scrollDivTop = g.scrollHeight - g.scrollDivHeight-2
		var groupTable = document.getElementById("groupTable")
		var groupScroll = -1 * (g.totalHeight) * (scrollDivTop/g.scrollHeight)
		groupScrollDiv.style.top = scrollDivTop + "px"
		groupTable.style.top= groupScroll + "px"
	},


	/*
	 *
	 */
	setGroupPanel : function(selectedGroupIndex) {

		   var f = foxTabWin
		   var inGroupList = function(url) {
				for(var i=1; i<f.groupList.length; i++) {
					if (f.groupList[i].d==url) {
						return i;
					}
				}
				return -1;
		   }

		   var div = document.getElementById("foxTab_div_groups_panel")

		   var rowHeight = 30
		   if (selectedGroupIndex==null) selectedGroupIndex = 0;
		   f.lastGroupIndex = selectedGroupIndex
		   
		   if (f.groupList!=null) f.groupList.length = 0;
		   f.groupList = new Array();		
		   f.groupList.push({d:"All", indices:new Array()})
		   var tabsList = foxTabWin.wo.tabsList
		   for (var i=0;i<tabsList.length;i++) {
			    if (tabsList[i].visible) {
					var currentBrowser = tabsList[i].tabBrowser
					if (currentBrowser.contentDocument) {
						try { // IeTab raise an error when using currentBrowser.contentDocument.domain
							if (currentBrowser.contentDocument.domain) {
								var domainName  = f.getDomainName(currentBrowser.contentDocument.domain)
							} else domainName = "Blank"
						}catch(e){
							domainName = "Unknown"
						}
					} else domainName = "Blank"
					var index = inGroupList(domainName)

					f.groupList[0].indices.push(i)
					if (index==-1) {
						f.groupList.push({d:domainName, indices:[i]})
					} else {
						f.groupList[index].indices.push(i);
					}
			    }
		   }
		   // sort by name
		   if (f.wo.pref.sortGroupByName) {
				f.groupList.sort(function(a, b){
					if (a.d=="All") return -1 
					  else if (b.d=="All") return 1 
					     else return a.d > b.d
				})
		   }

		   var totalHeight = (rowHeight * f.groupList.length) + 50 + 2 + f.groupList.length-1

		   var winWidth  = foxTabWin.wo.windowBoxObject.width
		   var winHeight = foxTabWin.wo.windowBoxObject.height
		   var top = winHeight/2 - totalHeight/2

		   div.style.left   = "-255px"
		   div.style.top    = "40px"
		   div.style.width  = "240px"

		   if (totalHeight>winHeight - 105 ) { // enableScroll

			   foxTabWin.groupParams = {}
			   var totalHeight     = totalHeight - 50 - 2
			   var groupsHeight	   = (winHeight - 145)
			   var scrollWidth     = 10
			   var scrollHeight    = groupsHeight - 20

			   var scrollDivHeight = (groupsHeight/totalHeight) * scrollHeight

			   foxTabWin.groupParams.totalHeight = totalHeight
			   foxTabWin.groupParams.groupsHeight = groupsHeight
			   foxTabWin.groupParams.scrollHeight = scrollHeight
			   foxTabWin.groupParams.scrollDivHeight = scrollDivHeight
				
			   var divStyle  = 'style="overflow-y:hidden;height:'+ groupsHeight +'px"'
			   var scrollDiv = '<html:table cellPadding="0" cellSpacing="0" style="border-collapse: collapse;"><html:tr><html:td height="10" background="chrome://foxtab/skin/images/groupsPanel/scroll_top.png" onclick="foxTabWin.groupScrollUp();" style="cursor:pointer"></html:td></html:tr><html:tr><html:td bgcolor="#303030" height="'+scrollHeight+'" valign="top"><html:div id="groupScrollDiv" style="position:relative;top:0px;width:'+ scrollWidth +'px;height:'+ scrollDivHeight +'px;background-color:#000000"></html:div></html:td></html:tr><html:tr><html:td height="10" background="chrome://foxtab/skin/images/groupsPanel/scroll_bottom.png" onclick="foxTabWin.groupScrollDown();" style="cursor:pointer"></html:td></html:tr></html:table>'
			   scrollHtml	 = '<html:td valign="top" width="'+ scrollWidth +'"><html:div>'+ scrollDiv +'</html:div></html:td>'
			   var maxDomainLength = 16;
		   } else {
			   foxTabWin.groupParams = null
			   divStyle = ""
			   scrollHtml = ""
			   var maxDomainLength = 17;
		   }

		   var groupsHTML = '<html:table width="237" cellPadding="0" cellSpacing="0" style="border-collapse: collapse;">'

						  + '<html:tr><html:td valign="top"><html:div '+ divStyle +'><html:table id="groupTable" cellPadding="0" cellSpacing="0" style="position:relative;top:0px;border-collapse: collapse;">'
						for (var i=0;i<f.groupList.length;i++) {
						  if (i==selectedGroupIndex) {
							arrowColor = "blue"
							icoImg = ""
						  } else {
							arrowColor = "green"
							if (f.groupList[i].d!="Blank") {
								path = 'http://www.'+ f.groupList[i].d+'/favicon.ico'
							  } else {
								path = 'chrome://foxtab/skin/images/groupsPanel/blank_icon.png'
							}
							icoImg ='<image src="'+ path +'" width="16" height="16" hspace="0" align="left" valign="top" border="0" style="outline: none;display:block"/>'
						  }
						  var domainName = f.groupList[i].d
						  if (domainName.length>maxDomainLength) domainName = domainName.substring(0,maxDomainLength)+"..."

						  groupsHTML	+= '<html:tr style="cursor:pointer" ondblclick="foxTabWin.onGroupItemDbClick('+ i +')" onmousedown="foxTabWin.onGroupItemClick('+ i +')" xonmouseover="this.style.backgroundColor=\'#ffffff\'" xonmouseout="this.style.backgroundColor=\'\'">'
										+  '<html:td width="20" height="16" valign="center" style="padding-left:15px">'+ icoImg +'</html:td>'
										+  '<html:td height="16" class="panel_text" valign="top">'+ domainName +' ('+ f.groupList[i].indices.length+')'
										+  '<html:img id="groups_arrow'+i+'" src="chrome://foxtab/skin/images/groupsPanel/'+ arrowColor +'_arrow.png" width="6" height="9" style="margin-left:7px"/></html:td>'

						  groupsHTML	+= '</html:tr>'
						}
		   groupsHTML	+= '</html:table></html:div></html:td>'


		   groupsHTML	+= scrollHtml

		   groupsHTML	+= '</html:tr></html:table>'

		   var panelHTML = '<html:table width="240" cellPadding="0" cellSpacing="0" style="border-collapse: collapse;">'
						    + '<html:tr><html:td width="240" height="23" class="panel_top_td"></html:td>'
						    + '<html:td width="10" valign="center" align="left" rowspan="4" style="padding:0px;margin:0px;"><html:img src="chrome://foxtab/skin/images/groupsPanel/close_white.png" title="Close panel." onclick="foxTabWin.closeGroupPanel()" onmouseover="this.src=\'chrome://foxtab/skin/images/groupsPanel/close_gray.png\'" onmouseout="this.src=\'chrome://foxtab/skin/images/groupsPanel/close_white.png\'" style="cursor:pointer;padding:0px;margin:0px;" width="10" height="90" hspace="0" vspace="0" align="left" valign="top"/></html:td></html:tr>'
						    + '<html:tr><html:td width="240" class="panel_middle_td">'+ groupsHTML +'</html:td></html:tr>'
						    + '<html:tr><html:td width="240" height="23" class="panel_bottom_td"></html:td></html:tr>'
						 + '</html:table>'

		   div.innerHTML = panelHTML
		   div.style.display = ''
	},
	/*
	 *
	 */
	setFilterTextBoxPosition : function(posX, posY, width, height) {

	   var div = document.getElementById("foxTab_div_filter_text")

	   var delta = 0;
	   var width = width - 0
	   var textbox_width  = (width * 8/10) - (delta * 5)
	   var textbox_height = 30

	   var textbox_width  = 226

	   posX = (posX-0) + ((width-textbox_width)/2) - 2 + delta +3;
	   posX = Math.round(posX)


	   posY = (posY-0) + ((height-textbox_height)/2) - 4 + 7

	   div.style.left = posX +"px"
	   div.style.top  = posY +"px"
	   var _iframe = document.getElementById("foxTab_div_filter_text")
	   _iframe.style.left = posX +"px"
	   _iframe.style.top  = posY +"px"
	   _iframe.style.width  = textbox_width +"px"
	   _iframe.style.height = textbox_height +"px"
	   _iframe.style.display = 'block'

	   var textbox = document.getElementById("foxTab_filter_textbox")
	   textbox.style.display = ''
	   textbox.style.color = "#" + foxTabWin.wo.pref.titleColor

	   textbox.style.width  = textbox_width +"px"

	   textbox.style.height = textbox_height +"px"

	   window.focus();
	   var g = setTimeout(foxTabWin.setFilterTextBoxToFocus,50); // workaround for textbox.focus();
	   
	   foxTabWin.isFilterTextBoxOpen = true;
	},
	/*
	 *
	 */
	setFilterTextBoxToFocus : function() {
	   var textbox = document.getElementById("foxTab_filter_textbox")
		textbox.focus();
	},
	/*
	 *
	 */
	hideFilterTextBox : function() {
	   var textbox = document.getElementById("foxTab_filter_textbox")
	   textbox.style.display = 'none'
	   // Workaround for Linux, to disaply div above flash
	   if (foxTabWin.wo.OS==foxTabWin.wo.LINUX) {
		   var bg_iframe = document.getElementById("foxTab_iframe_filter_text")
		   bg_iframe.style.display = 'none'
	   }
	   foxTabWin.isFilterTextBoxOpen = false;
	},
	/*
	 *
	 */
	filterBoxKeyUp : function(textBox, event) {
		switch (event.keyCode) {
			case event.DOM_VK_DOWN:
			case event.DOM_VK_RIGHT:
			case event.DOM_VK_LEFT:
			case event.DOM_VK_UP:
			case event.DOM_VK_CONTROL:
			case event.DOM_VK_ALT:
			case event.DOM_VK_TAB:
			case event.DOM_VK_SHIFT:
			break;
			default:
				if (foxTabWin.filterInterval!=null) {
					clearInterval(foxTabWin.filterInterval);
				}
				foxTabWin.filterInterval = setTimeout(foxTabWin.filterTabs, 50, textBox.value);
			break;
		}
	},
	/*
	 *
	 */
	filterTabs : function(text) {
		var resultTabsList = foxTabWin.wo.filterTabsByText(text);

		// if we filter all the tabs that are open, highlight the text to be red
		var textBoxStyle = document.getElementById("foxTab_filter_textbox").style
		if (resultTabsList.length == 0) {
			textBoxStyle.color = "#DA7272"
		} else {
			textBoxStyle.color = "#" + foxTabWin.wo.pref.titleColor
		}
		foxTabWin.foxTabFlash.execute("","filterTabs",resultTabsList.join("^"))
	},
	/*
	 *
	 */
	openSearchPanel : function() {
		if (foxTabWin.isFilterTextBoxOpen) {
			var textbox = document.getElementById("foxTab_filter_textbox")
			textbox.focus();			
		} else {
			foxTabWin.foxTabFlash.execute("","openSearchPanel")
		}
	},
	/*
	 *
	 */
	closeSearchPanel : function() {
		foxTabWin.foxTabFlash.execute("","closeSearchPanel")
	},
	/*
	 *
	 */
	closeTab : function(windowId, windowIndex, tabIndex) {
			var closeByWindow = function(url, foxTabObject) {
				
				var browser = foxTabObject.gBrowser
				var numTabs = browser.tabContainer.childNodes.length;
				var currentBrowser, url;
				var tabsToRemove = new Array();


				for(var j=0; j<numTabs; j++) {
				   currentBrowser = browser.getBrowserAtIndex(j);
				   if (url==currentBrowser.currentURI.spec) {
						tabsToRemove.push(browser.tabContainer.childNodes[j]);
				   }						   
				}

				for (var j=0;j<tabsToRemove.length;j++) {
					if (browser.tabContainer.childNodes.length==1) {
						foxTabObject.win.close();
					} else {
						browser.removeTab(tabsToRemove[j])
					}
				}				
			}
			/////////////////////////////////////////////////////

			var browser    = foxTabWin.wo.tabsList[tabIndex].tabBrowser

			if (!foxTabWin.wo.pref.hideDuplicateTabs) {
				 var foxTabObject = foxTabWin.wo.getWindowById(windowId-0);
				 if (foxTabObject!=null) {
					 if (foxTabObject.gBrowser.tabContainer.childNodes.length==1) {
						 foxTabObject.win.close();
					 } else {
						 foxTabObject.gBrowser.removeTab(foxTabWin.wo.tabsList[tabIndex].tab)
					 }
				 }
			} else {
				var foxTabList = foxTabWin.wo.getAllFoxTabObjects();
				var url		   = browser.currentURI.spec

				if (foxTabWin.wo.pref.multipleWindows) {
					for (var i=0;i<foxTabList.length;i++) {
						closeByWindow(url, foxTabList[i]);
					}
				} else {
					closeByWindow(url, foxTabWin.wo);
				}
			}
	},
	/*
	 *
	 */
	onCommand : function(evt,args) {
		var params = args.split("^");
		switch (params[0].toLowerCase()) {
			case "close":
					 foxTabWin.closeFoxTab();
					break;	
			case "open_options":
					 foxTabWin.wo.openOptions();
			break;		
			case "bookmark_this_tab":
				
			break;				
			case "open_in_a_new_tab":
					foxTabWin.closeFoxTab();

					var foxTabObject = foxTabWin.wo.getWindowById(params[1]);
					if (foxTabObject!=null) {
						 var b = foxTabObject.gBrowser
					 	 var currentBrowser = foxTabWin.wo.tabsList[params[3]].tabBrowser
						 b.selectedTab = b.addTab(currentBrowser.currentURI.spec)
						 if (foxTabObject!=foxTabWin.wo) foxTabObject.win.focus();
					}
			break;			
			case "open_tab_in_new_window":
					foxTabWin.closeFoxTab();
					var foxTabObject = foxTabWin.wo.getWindowById(params[1]);
					if (foxTabObject!=null) {
						 var b = foxTabObject.gBrowser
						 var currentBrowser = foxTabWin.wo.tabsList[params[3]].tabBrowser
						 window.open(currentBrowser.currentURI.spec)	
					}
			break;							
			case "close_tab":
					foxTabWin.closeTab(params[1], params[2], params[3])
			break;
			case "set_text_position":
					if (foxTabWin.wo.pref.siteTitle) foxTabWin.setTextPosition(params[1], params[2], params[3], params[4], params[5]);
			break;
			case "set_filter_textbox_position":
					foxTabWin.setFilterTextBoxPosition(params[1], params[2], params[3], params[4]);
			break;
			case "hide_filter_textbox":
					foxTabWin.hideFilterTextBox();
					if (params[1]=="1") {
						var div = document.getElementById("foxTab_div_groups_panel")
						div.style.display='none'
						if (foxTabWin.wo.OS==foxTabWin.wo.LINUX) {
							 var bg_iframe = document.getElementById("foxTab_iframe_groups") // only linux
						  	 bg_iframe.style.display='none'
						}
					}
			break;
			case "filter_textbox_closed":
				  if (foxTabWin.wo.pref.findClearFilter) foxTabWin.clearAllFilter();
			break;
			case "hide_title":
			        document.getElementById("foxTab_div_text").style.display = "none"
			break;
			case "mode_change":
					var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
					ffPreferences.setCharPref("foxTab.mode", params[1]);
					var foxTabList = foxTabWin.wo.getAllFoxTabObjects();
					for (var i=0;i<foxTabList.length;i++) {
					  foxTabList[i].pref.mode = params[1]-0
					}
			break;
			case "full_screen":
			break;
			case "show_hide_group_panel":
					if (!foxTabWin.isGroupPanelOpen) {		
						foxTabWin.setGroupPanel();
						foxTabWin.openGroupPanel(true);
					} else {
						foxTabWin.closeGroupPanel();
					}
			break;
			case "open_welcome":
						 foxTabWin.wo.gBrowser.selectedTab = foxTabWin.wo.gBrowser.addTab("http://www.foxtab.com/welcome/")	
			break;
			case "set_mode_view_params":
						var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
						ffPreferences.setCharPref("foxTab.layout.carouselParams", params[1]);
						ffPreferences.setCharPref("foxTab.layout.rowParams", params[2]);
						ffPreferences.setCharPref("foxTab.layout.slidesParams", params[3]);
						ffPreferences.setCharPref("foxTab.layout.pageFlowParams", params[4]);
						ffPreferences.setCharPref("foxTab.layout.wallParams", params[5]);
						ffPreferences.setCharPref("foxTab.layout.gridParams", params[6]);

						var foxTabList = foxTabWin.wo.getAllFoxTabObjects();
						for (var i=0;i<foxTabList.length;i++) {
						   foxTabList[i].pref.carouselParams = params[1]
						   foxTabList[i].pref.rowParams      = params[2]
						   foxTabList[i].pref.slidesParams   = params[3]
						   foxTabList[i].pref.pageFlowParams = params[4]
						   foxTabList[i].pref.wallParams     = params[5]
						   foxTabList[i].pref.gridParams     = params[6]
						}
			break;


			case "set_theme_item":
						var foxTabList = foxTabWin.wo.getAllFoxTabObjects();
						for (var i=0;i<foxTabList.length;i++) {
							if (foxTabList[i].foxTabWin!=null) {
								if (foxTabList[i].foxTabWin.foxTabFlash!=null) {
									foxTabList[i].foxTabWin.foxTabFlash.execute("","setThemeItem", 
																				params[1],
																				params[2])
								}
							}

						}
			break;

			case "set_theme":
						var themeStr = params[1] + "," + params[2] + "," + params[3] + "," + params[4]
						var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
						ffPreferences.setCharPref("foxTab.theme", themeStr);
						ffPreferences.setCharPref("foxTab.theme.titleColor", params[5]);
						ffPreferences.setCharPref("foxTab.theme.useTheme", params[6]);
						ffPreferences.setCharPref("foxTab.theme.customColors", params[7]);
						var foxTabList = foxTabWin.wo.getAllFoxTabObjects();
						for (var i=0;i<foxTabList.length;i++) {
							foxTabList[i].pref.theme        = themeStr
							foxTabList[i].pref.titleColor   = params[5]
							foxTabList[i].pref.useTheme     = params[6]
							foxTabList[i].pref.customColors = params[7]

							if (foxTabList[i].foxTabWin!=null) {
								if (foxTabList[i].foxTabWin.foxTabFlash!=null) {
									foxTabList[i].foxTabWin.foxTabFlash.execute("","setTheme", 
																				params[1],
																				params[2],
																				params[3],
																				params[4])
								}
							}

						}
						document.getElementById("foxTab_siteTitle").style.color = "#" + foxTabWin.wo.pref.titleColor
						document.getElementById("foxTab_filter_textbox").style.color = "#" + foxTabWin.wo.pref.titleColor
						
			break;
			case "set_background_image":
						foxTabWin.saveBackgroundImage(params[1]);
			break;
			case "browse_background_image":
						foxTabWin.browseBackgroundImage();
			break;
			case "clear_background_image":
						var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
						ffPreferences.setBoolPref("foxTab.theme.displayBgImage", false);
						foxTabWin.removeBackgroundImage();
			break;
			case "clear_first_launch":
						var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
						ffPreferences.setBoolPref("foxTab.isFirstLaunch", false);
			break;
			case "right_panel_open":
						foxTabWin.rightPanelOpen = true
						 document.getElementById("foxTab_div_text").style.display = "none"
			break;	
			case "right_panel_closed":
						foxTabWin.rightPanelOpen = false
			break;		
			case "share":
						foxTabWin.wo.gBrowser.selectedTab = foxTabWin.wo.gBrowser.addTab(params[1])	
			break;	


		}
	},
 	onBackgroundImageSaved : function() {
		var foxTabList = foxTabWin.wo.getAllFoxTabObjects();
		for (var i=0;i<foxTabList.length;i++) {
			if (foxTabList[i].foxTabWin!=null) {
				if (foxTabList[i].foxTabWin.foxTabFlash!=null) {
					foxTabList[i].foxTabWin.foxTabFlash.execute("","backgroundImageSaved", foxTabWin.wo.FOXTAB_DIR + "bg_image.png")
					foxTabList[i].pref.displayBgImage = true;
				}
			}
		}

		var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		ffPreferences.setBoolPref("foxTab.theme.displayBgImage", true);
	},
 	onBackgroundImageError : function() {
		foxTabWin.foxTabFlash.execute("","backgroundImageError")
	},
	removeBackgroundImage : function() {
		var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		try {
			file.initWithPath(foxTabWin.wo.FOXTAB_DIR + "bg_image.png");
			file.remove(false);
		} catch (e) {
		}

		var foxTabList = foxTabWin.wo.getAllFoxTabObjects();
		for (var i=0;i<foxTabList.length;i++) {
			if (foxTabList[i].foxTabWin!=null) {
				if (foxTabList[i].foxTabWin.foxTabFlash!=null) {
					foxTabList[i].foxTabWin.foxTabFlash.execute("","clearBackgroundImage")
					foxTabList[i].pref.displayBgImage = false;
				}
			}
		}
	},
	browseBackgroundImage : function() {
		const nsIFilePicker = Components.interfaces.nsIFilePicker;

		var fp = Components.classes["@mozilla.org/filepicker;1"]
					   .createInstance(nsIFilePicker);
		fp.init(window, "Select Image", nsIFilePicker.modeOpen);
		fp.appendFilters(nsIFilePicker.filterImages);

		var rv = fp.show();
		var path = ""
		if (rv == nsIFilePicker.returnOK || rv == nsIFilePicker.returnReplace) {
		  var file = fp.file;
		  var path = fp.file.path;
		  url = path;
		}
		if (path=="") {
			foxTabWin.onBackgroundImageError();
		} else {
			foxTabWin.saveBackgroundImage(path, true);
		}
	},
	saveBackgroundImage : function(url, localPath) {
		var file = Components.classes["@mozilla.org/file/local;1"]  
					.createInstance(Components.interfaces.nsILocalFile);  
		file.initWithPath(foxTabWin.wo.FOXTAB_DIR + "bg_image.png");  
		var wbp = Components.classes['@mozilla.org/embedding/browser/nsWebBrowserPersist;1']  
				  .createInstance(Components.interfaces.nsIWebBrowserPersist);  
		var ios = Components.classes['@mozilla.org/network/io-service;1']  
				  .getService(Components.interfaces.nsIIOService);  

		if (localPath) {
			if (url.indexOf("file://")==-1)  url = "file:///" + url
		} else {
			if ((url.indexOf("http://")==-1) && (url.indexOf("https://")==-1) && (url.indexOf("ftp://")==-1) && (url.indexOf("chrome://")==-1)) {
				if ((url.indexOf(".com")==-1) && (url.indexOf("www")==-1)) {
					if (url.indexOf(":\\")<3) url = "file:///" + url
					 else url = "http://" + url
				} else {
					url = "http://" + url
				}
			}
		}

		try {
			
			 var uri = ios.newURI(url, null, null); 
			 wbp.progressListener = {
			  onProgressChange: function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {
				if (aCurTotalProgress>=aMaxTotalProgress) {
					foxTabWin.onBackgroundImageSaved();
				}
			  },
			  onStateChange: function(aWebProgress, aRequest, aStatus, aMessage) {
				  if (aMessage==2152398878) {
						foxTabWin.onBackgroundImageError();
				  }
			   }
			 }
			 wbp.saveURI(uri, null, null, null, null, file);
		} catch (e) {
			 foxTabWin.onBackgroundImageError();
		}
	},
	/*
	 *
	 */
	setFlashImages : function(forceCallBack) {
		   var f = foxTabWin
		   f.flashCallBack = 0;
		   var params = f.wo.getTabs();
		   if (f.wo.loadOnFirefoxStart) {
				a = f.foxTabFlash.execute("","initImages",params.args)
			} else {
			    f.foxTabFlash.setArgs(params.args)
		   }
		   f.selectedIndex = params.selectedIndex
		   f.numTabs		 = params.numTabs

		   if (forceCallBack!=false) f.wo.startCheckCallBack()
	},
	/*
	 *
	 */
	checkCallBack : function() {
		if (foxTabWin.flashCallBack==0) {
			 document.getElementById("winBox").style.visibility = ""
			 foxTabWin.setFlashImages()

		}
	},
	/*
	 *
	 */
	onCallBack : function() {
		var f = foxTabWin

		f.flashCallBack = 1
		var width  = f.wo.windowBoxObject.width
		var height = f.wo.windowBoxObject.height

		f.foxTabFlash.object.style.width  = width +"px"
		f.foxTabFlash.object.style.height = height +"px"

		f.startWindowPositionInterval();
	    var textbox = document.getElementById("foxTab_filter_textbox")
	    textbox.value = ""

		foxTabWin.isFullScreen = false
	
		if ((f.wo.pref.interactive_size=="small") || (foxTabWin.wo.launchMode==foxTabWin.wo.LAUNCH_MODE_QUICK)) { 
			f.isGroupPanelOpen = false
			f.isFilterTextBoxOpen = false;
		  } else {
			
			switch (f.wo.pref.groupOpen-0) {
				case 0:
						f.isGroupPanelOpen = false
				break;
				case 1:
						f.setGroupPanel();
						f.openGroupPanel(false);
				break;
				case 2:
					if (f.isGroupPanelOpen) {		
						f.setGroupPanel();
						f.openGroupPanel(false);
					}
				break;
			}

			if (f.wo.pref.filterOpen-0==0) f.isFilterTextBoxOpen = false;
		}

		f.wo.onCallBack();
		

		try {
			if (!f.isFlash10) {
				var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
				displayOldVerMessage  = ffPreferences.getBoolPref("foxTab.general.displayOldVerMessage");
				if (displayOldVerMessage) {
					f.openOldVersionMessage();
				}
			}
		} catch (e) {}
	},
	/*
	 *
	 */
	checkWindowPosition : function() {
		if (foxTabWin.wo.canvasType==foxTabWin.wo.CANVAS_WIN) {
			if ((foxTabWin.lastWindowX!=foxTabWin.wp.screenX) || (foxTabWin.lastWindowY!=foxTabWin.wp.screenY)) {
				foxTabWin.lastWindowX = foxTabWin.wp.screenX
				foxTabWin.lastWindowY = foxTabWin.wp.screenY
				foxTabWin.wo.onResize();
			}		
		} else {
			if ((foxTabWin.lastBrowserWidth!=foxTabWin.tabpanelsBox.width) || (foxTabWin.lastBrowserHeight!=foxTabWin.tabpanelsBox.height)) {
					foxTabWin.lastBrowserWidth  = foxTabWin.tabpanelsBox.width
					foxTabWin.lastBrowserHeight = foxTabWin.tabpanelsBox.height	
					foxTabWin.wo.onResize();
			}		
		}
	},
	/*
	 *
	 */
	startWindowPositionInterval : function() {
		foxTabWin.stopWindowPositionInterval();

		
		if (foxTabWin.wo.canvasType==foxTabWin.wo.CANVAS_WIN) {
			foxTabWin.lastWindowX = foxTabWin.wp.screenX
			foxTabWin.lastWindowY = foxTabWin.wp.screenY
			foxTabWin.windowPositionInterval = setInterval(foxTabWin.checkWindowPosition, 2500);
		} else {
			if ((foxTabWin.wo.launchMode==foxTabWin.wo.LAUNCH_MODE_INTERACTIVE) && (foxTabWin.wo.pref.interactive_size=="fitToBrowser")) {
				try {
					foxTabWin.tabpanelsBox = foxTabWin.wo.gBrowser.mTabBox.tabpanels.boxObject
					foxTabWin.lastBrowserWidth  = foxTabWin.tabpanelsBox.width
					foxTabWin.lastBrowserHeight = foxTabWin.tabpanelsBox.height
					foxTabWin.windowPositionInterval = setInterval(foxTabWin.checkWindowPosition, 1500);
				} catch (e) {}
			}
		}
	},
	/*
	 *
	 */
	stopWindowPositionInterval : function() {
		if (foxTabWin.windowPositionInterval!=null) {
			clearInterval(foxTabWin.windowPositionInterval);
			foxTabWin.windowPositionInterval = null;
		}
	},
	/*
	 *
	 */
	onResize : function() { 

		var f = foxTabWin

		var width  = foxTabWin.wp.document.width
		var height = 20
		var width  = f.wo.windowBoxObject.width
		var height = f.wo.windowBoxObject.height

		if (f.wo.windowBoxObject.left<0) f.wo.windowBoxObject.left = 0;
	  	if (foxTabWin.wo.OS!=foxTabWin.wo.LINUX) {
			document.getElementById("main_div").style.width  = width +"px"
			document.getElementById("main_div").style.height = height +"px"

			document.getElementById("foxTab_main_flash_div").style.width = width +"px"
			document.getElementById("foxTab_main_flash_div").style.height = height +"px"
		} else {
			document.getElementById("foxTab_div_text").style.width = width +"px"
		}

		if (f.wo.isFlashOpen) {
			f.foxTabFlash.object.style.width  = width +"px"
			f.foxTabFlash.object.style.height = height +"px"

			if (width<400) {
				if (foxTabWin.isGroupPanelOpen) {		
					foxTabWin.closeGroupPanel();
				}				
			}
		    if (foxTabWin.isGroupPanelOpen) {
			   var rowHeight = 30;
			   var totalHeight = (rowHeight * foxTabWin.groupList.length) + 50 + 2 + foxTabWin.groupList.length-1
			   if (totalHeight>height - 105 ) {
					foxTabWin.setGroupPanel();
					foxTabWin.openGroupPanel(false);
			   } else {
					if (foxTabWin.groupParams!=null) {
						foxTabWin.setGroupPanel();
						foxTabWin.openGroupPanel(false);
					}
			   }
		    }
		}
	},
	resizeTimeOut  : function(newSize) { 
		setTimeout(foxTabWin.wo.resize, 250, newSize);	
	},	
	/*
	 *
	 */
	getTooltipString  : function() { 
		var tooltipStr = ""
		try {
			var strbundle = document.getElementById("foxTab_stringbundle");
			var tooltip_list = new Array();
			tooltip_list.push(strbundle.getString("hint_Carousel"));
			tooltip_list.push(strbundle.getString("hint_Row"));
			tooltip_list.push(strbundle.getString("hint_Grid"));
			tooltip_list.push(strbundle.getString("hint_Stack"));
			tooltip_list.push(strbundle.getString("hint_PageFlow"));
			tooltip_list.push(strbundle.getString("hint_Wall"));
			tooltip_list.push(strbundle.getString("hint_Close"));
			tooltip_list.push(strbundle.getString("hint_ThemeSelection"));
			tooltip_list.push(strbundle.getString("hint_Controller"));
			tooltip_list.push(strbundle.getString("hint_FullScreen"));
			tooltip_list.push(strbundle.getString("hint_Find"));
			tooltip_list.push(strbundle.getString("hint_Options"));
			tooltip_list.push(strbundle.getString("hint_Grouping"));
			tooltip_list.push(strbundle.getString("hint_NumberOfTabs"));
			tooltip_list.push(strbundle.getString("hint_share"));
			tooltipStr = tooltip_list.join("~");
		} catch (e) {}
		return tooltipStr;
	},	
	/*
	 *
	 */
	releaseFlash : function() { 
		var foxTab     = foxTabWin.wo;
		var isOpen     = foxTab.isFlashOpen;
		var launchMode = foxTab.launchMode;

		if (isOpen) foxTab.closeFoxTab();
		var pos = foxTab.getInitialWinPosition();
		foxTab.moveFrame(pos.left, pos.top);
		document.getElementById("main_div").innerHTML = "";
	},
	/*
	 * 
	 */
 	openOldVersionMessage : function() {
		var winWidth  = foxTabWin.wo.windowBoxObject.width
	    var winHeight = foxTabWin.wo.windowBoxObject.height

		var posX = winWidth/2 - 550/2;
		var posY = winHeight/2 - 350/2 - 50;

		var div_info_panel = document.getElementById("foxTab_div_info_panel");

		div_info_panel.style.left = posX + "px";
		div_info_panel.style.top  = posY + "px";


		var strbundle = document.getElementById("foxTab_stringbundle");
		var msg_title = strbundle.getString("old_flash_msg_title")

		var innerHTML = "<html:iframe src='chrome://foxtab/content/flashVersionMessage.html' width='550' height='350' frameborder='0' scrolling='no' style='border:1px solid #454545'/>"

		if (div_info_panel.innerHTML=="") {
			div_info_panel.innerHTML = innerHTML
		}
		
	},
	removeOldVersionMessage : function() {
		var div_info_panel = document.getElementById("foxTab_div_info_panel");
		div_info_panel.innerHTML = ""
		div_info_panel.style.left = "-1px";
		var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		ffPreferences.setBoolPref("foxTab.general.displayOldVerMessage", false);
	},
	/*
	 *
	 */
	detectFlashVersion : function() { 
		  var f = foxTabWin;
		  var foxTab = f.wo;

		  var requiredMajorVersion = 9;
		  var requiredMinorVersion = 0;
		  var requiredRevision = 0;
		  var version = AC_DetectFlashVer(requiredMajorVersion, requiredMinorVersion, requiredRevision);

		  var hasReqestedVersion = version.hasReqestedVersion;


		  if ((hasReqestedVersion==null) && (hasReqestedVersion!=true) && (hasReqestedVersion!=false)) hasReqestedVersion = true;
		  foxTab.isFlashPlayerInstalled = hasReqestedVersion

		  if ((foxTab.pref.flashVer=="9") || (foxTab.pref.flashVer=="10")) foxTab.isFlashPlayerInstalled = true;

		  f.isFlash10 = false;

		  if (foxTab.pref.flashVer=="9") {
				f.isFlash10 = false;
		  } else if (foxTab.pref.flashVer=="10") {
				f.isFlash10 = true;
		  } else if (version.versionMajor-0>=10) {
				f.isFlash10 = true;
		  }
	},
	/*
	 *
	 */
	writeFlash : function() { 
		  var f = foxTabWin;
		  var foxTab = f.wo;

		  if (!foxTab.isFlashPlayerInstalled) {
			  document.getElementById("main_div").innerHTML = "<html:div id='foxTab_main_flash_div' style='width:100%;height:100%;text-align:center;'><html:table align='center' width='682' height='594' background='chrome://foxtab/skin/images/flashplayerMessage.jpg'><html:tr><html:td width='261' valign='top' align='left' style='padding-left:71px;padding-top:477px;color:#ffffff'><html:div style='width:290px;height:88px;cursor:pointer;' onclick='foxTabWin.wo.openAdobeFlashPlayerSite();'></html:div></html:td><html:td valign='top' align='left' style='padding-left:204px;padding-top:5px;color:#ffffff'><html:div style='width:22px;height:22px;cursor:pointer;' onclick='foxTabWin.wo.closeFoxTab();'></html:div></html:td></html:tr></html:table></html:div>" 
			  document.getElementById("winBox").style.visibility=""
		  } else {
			  var width  = f.wo.windowBoxObject.width
			  var height = f.wo.windowBoxObject.height
			  if (height==0) height = 25;
			 
			  if (f.isFlash10) {
				 var flashName = "foxTab_flash10.swf?"
			  } else {
				 var flashName = "foxTab_flash8.swf?"
			  }
			  var flashCache = "v1_2beta"
			  flashName += flashCache

			  f.foxTabFlash.init("foxTabFlash", width, height, flashName, "1A1A1A", true, f.isFlash10)
			  try {
				 var tooltips = f.getTooltipString();
				 f.foxTabFlash.setArgs("args=" + foxTab.FOXTAB_DIR + "^" + 
											     foxTab.pref.isFirstLaunch + "^" + 
											     foxTab.pref.theme + "^" + 
												 foxTab.pref.customColors + "^" + 
											     foxTab.pref.useTheme + "^" +
												 foxTab.pref.displayBgImage + "^" +
												 tooltips);
			  } catch (e) {}
			  if (!foxTab.loadOnFirefoxStart) {
				  f.setFlashImages();
				  document.getElementById("winBox").style.visibility = ""
			  }
			  f.foxTabFlash.write(document.getElementById("main_div"))
			  f.onResize()
		
			  foxTab_eventManager.add("foxTabFlash",f.onMouseWheel,"mousewheelevent")
			  foxTab_eventManager.add("foxTabFlash",f.onCommand,"command")
			  foxTab_eventManager.add("foxTabFlash",f.onTabSelected,"tabSelected")
			  foxTab_eventManager.add("foxTabFlash",f.onImageCorrupted,"imageCorrupted")
			  
			  foxTab_eventManager.add("foxTabFlash",f.onCallBack,"callBack")

			  document.getElementById("foxTab_div_groups_panel").addEventListener('DOMMouseScroll',f.onGroupPanelScroll, false);

		  }
	},
	/*
	 *
	 */
	onLoad : function() { 
		  var f = foxTabWin
		  foxTabWin.wp.foxTab.foxTabWin = foxTabWin
		  f.detectFlashVersion();
		  f.writeFlash();
	},
	/*
	 *
	 */
	closeFoxTab : function() { 
		 foxTabWin.wp.focus();
		 foxTabWin.wo.closeFoxTab();
	},
	/*
	 *
	 */
	onFoxTabClosed : function() { 
		var font = document.getElementById("foxTab_siteTitle")
		if (font!=null) font.innerHTML = ""
		foxTabWin.stopWindowPositionInterval();
	    try {
		  var textbox = document.getElementById("foxTab_filter_textbox")
		  textbox.style.display = 'none'
	      if (foxTabWin.wo.OS==foxTabWin.wo.LINUX) {
		  	 var bg_iframe = document.getElementById("foxTab_iframe_filter_text")
		  	 bg_iframe.style.display = 'none'
	 	  }

		  div = document.getElementById("foxTab_div_groups_panel")
		  div.style.display='none'
	    } catch (e) {
		}
	},
	/*
	 *
	 */
	flashBlockEvent : function(e) { 
		e.preventDefault();
		e.stopPropagation();
	}
}


function foxTabFlash_DoFSCommand(id_evt, args) {
	  var splitId_Evt = id_evt.split("^")
	  objectId = splitId_Evt[0]
	  evt = splitId_Evt[1]
	  var i;
		
	  foxTab_eventManager.executeEvent(objectId,evt,args)
}

foxTabWin.init();